/* game.c generated by valac 0.29.2.13-e9504, the Vala compiler
 * generated from game.vala, do not modify */

/*
 * Copyright (C) 2010-2013 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 2 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib.h>
#include <glib-object.h>
#include <math.h>


#define TYPE_TILE (tile_get_type ())
#define TILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TILE, Tile))
#define TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TILE, TileClass))
#define IS_TILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TILE))
#define IS_TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TILE))
#define TILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TILE, TileClass))

typedef struct _Tile Tile;
typedef struct _TileClass TileClass;
typedef struct _TilePrivate TilePrivate;

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
typedef struct _GamePrivate GamePrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))

struct _Tile {
	GObject parent_instance;
	TilePrivate * priv;
	gint grid_x;
	gint grid_y;
	gint color;
	gboolean visited;
};

struct _TileClass {
	GObjectClass parent_class;
};

struct _TilePrivate {
	gboolean _closed;
};

struct _Game {
	GObject parent_instance;
	GamePrivate * priv;
};

struct _GameClass {
	GObjectClass parent_class;
};

struct _GamePrivate {
	Tile** tiles;
	gint tiles_length1;
	gint tiles_length2;
	gboolean is_started;
	gint _score;
	gint _color_num;
	gint _rows;
	gint _columns;
};


static gpointer tile_parent_class = NULL;
static gpointer game_parent_class = NULL;

GType tile_get_type (void) G_GNUC_CONST;
#define TILE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TILE, TilePrivate))
enum  {
	TILE_DUMMY_PROPERTY,
	TILE_CLOSED
};
Tile* tile_new (gint x, gint y, gint c);
Tile* tile_construct (GType object_type, gint x, gint y, gint c);
void tile_update_position (Tile* self, gint new_x, gint new_y);
gboolean tile_get_closed (Tile* self);
void tile_set_closed (Tile* self, gboolean value);
static void g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void tile_finalize (GObject* obj);
static void _vala_tile_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_tile_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType game_get_type (void) G_GNUC_CONST;
#define GAME_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_GAME, GamePrivate))
enum  {
	GAME_DUMMY_PROPERTY,
	GAME_SCORE,
	GAME_COLOR_NUM,
	GAME_ROWS,
	GAME_COLUMNS
};
Game* game_new (gint rows, gint columns, gint color_num);
Game* game_construct (GType object_type, gint rows, gint columns, gint color_num);
static GList* _game_connected_tiles (Game* self, Tile* li);
gint game_get_rows (Game* self);
gint game_get_columns (Game* self);
static void _g_object_unref0_ (gpointer var);
static void _g_list_free__g_object_unref0_ (GList* self);
GList* game_connected_tiles (Game* self, Tile* li);
Tile* game_get_tile (Game* self, gint x, gint y);
gboolean game_remove_connected_tiles (Game* self, Tile* tile);
void game_increment_score_from_tiles (Game* self, gint n_tiles);
gboolean game_has_completed (Game* self);
gboolean game_has_won (Game* self);
void game_increment_score (Game* self, gint increment);
void game_reset_visit (Game* self);
gint game_get_score (Game* self);
void game_set_score (Game* self, gint value);
gint game_get_color_num (Game* self);
void game_set_color_num (Game* self, gint value);
void game_set_rows (Game* self, gint value);
void game_set_columns (Game* self, gint value);
static void game_finalize (GObject* obj);
static void _vala_game_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_game_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


Tile* tile_construct (GType object_type, gint x, gint y, gint c) {
	Tile * self = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
#line 40 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self = (Tile*) g_object_new (object_type, NULL);
#line 42 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0_ = x;
#line 42 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self->grid_x = _tmp0_;
#line 43 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp1_ = y;
#line 43 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self->grid_y = _tmp1_;
#line 44 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp2_ = c;
#line 44 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self->color = _tmp2_;
#line 40 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	return self;
#line 159 "game.c"
}


Tile* tile_new (gint x, gint y, gint c) {
#line 40 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	return tile_construct (TYPE_TILE, x, y, c);
#line 166 "game.c"
}


void tile_update_position (Tile* self, gint new_x, gint new_y) {
	gint old_x = 0;
	gint _tmp0_ = 0;
	gint old_y = 0;
	gint _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
#line 48 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_return_if_fail (self != NULL);
#line 50 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0_ = self->grid_x;
#line 50 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	old_x = _tmp0_;
#line 51 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp1_ = self->grid_y;
#line 51 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	old_y = _tmp1_;
#line 53 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp3_ = new_x;
#line 53 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp4_ = old_x;
#line 53 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if (_tmp3_ != _tmp4_) {
#line 53 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp2_ = TRUE;
#line 196 "game.c"
	} else {
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
#line 53 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp5_ = new_y;
#line 53 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp6_ = old_y;
#line 53 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp2_ = _tmp5_ != _tmp6_;
#line 206 "game.c"
	}
#line 53 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if (_tmp2_) {
#line 210 "game.c"
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
		gboolean _tmp9_ = FALSE;
		gboolean _tmp10_ = FALSE;
#line 55 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp7_ = new_x;
#line 55 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		self->grid_x = _tmp7_;
#line 56 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp8_ = new_y;
#line 56 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		self->grid_y = _tmp8_;
#line 59 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp9_ = tile_get_closed (self);
#line 59 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp10_ = _tmp9_;
#line 59 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		if (!_tmp10_) {
#line 229 "game.c"
			gint _tmp11_ = 0;
			gint _tmp12_ = 0;
			gint _tmp13_ = 0;
			gint _tmp14_ = 0;
#line 60 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
			_tmp11_ = old_x;
#line 60 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
			_tmp12_ = old_y;
#line 60 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
			_tmp13_ = new_x;
#line 60 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
			_tmp14_ = new_y;
#line 60 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
			g_signal_emit_by_name (self, "move", _tmp11_, _tmp12_, _tmp13_, _tmp14_);
#line 244 "game.c"
		}
	}
}


gboolean tile_get_closed (Tile* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 20 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 20 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0_ = self->priv->_closed;
#line 20 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	result = _tmp0_;
#line 20 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	return result;
#line 261 "game.c"
}


void tile_set_closed (Tile* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 21 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_return_if_fail (self != NULL);
#line 23 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0_ = value;
#line 23 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self->priv->_closed = _tmp0_;
#line 25 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp1_ = self->priv->_closed;
#line 25 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if (_tmp1_) {
#line 278 "game.c"
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
#line 26 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp2_ = self->grid_x;
#line 26 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp3_ = self->grid_y;
#line 26 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		g_signal_emit_by_name (self, "close", _tmp2_, _tmp3_);
#line 287 "game.c"
	}
#line 21 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_object_notify ((GObject *) self, "closed");
#line 291 "game.c"
}


static void g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__INT_INT_INT_INT) (gpointer data1, gint arg_1, gint arg_2, gint arg_3, gint arg_4, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_return_if_fail (n_param_values == 5);
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		data1 = closure->data;
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		data2 = param_values->data[0].v_pointer;
#line 310 "game.c"
	} else {
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		data1 = param_values->data[0].v_pointer;
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		data2 = closure->data;
#line 316 "game.c"
	}
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	callback = (GMarshalFunc_VOID__INT_INT_INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), g_value_get_int (param_values + 4), data2);
#line 322 "game.c"
}


static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__INT_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_return_if_fail (n_param_values == 3);
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		data1 = closure->data;
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		data2 = param_values->data[0].v_pointer;
#line 341 "game.c"
	} else {
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		data1 = param_values->data[0].v_pointer;
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		data2 = closure->data;
#line 347 "game.c"
	}
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	callback = (GMarshalFunc_VOID__INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 353 "game.c"
}


static void tile_class_init (TileClass * klass) {
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	tile_parent_class = g_type_class_peek_parent (klass);
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_type_class_add_private (klass, sizeof (TilePrivate));
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tile_get_property;
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tile_set_property;
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	G_OBJECT_CLASS (klass)->finalize = tile_finalize;
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TILE_CLOSED, g_param_spec_boolean ("closed", "closed", "closed", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_signal_new ("move", TYPE_TILE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_INT_INT, G_TYPE_NONE, 4, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT);
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_signal_new ("close", TYPE_TILE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_INT);
#line 374 "game.c"
}


static void tile_instance_init (Tile * self) {
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self->priv = TILE_GET_PRIVATE (self);
#line 17 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self->priv->_closed = FALSE;
#line 33 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self->visited = FALSE;
#line 385 "game.c"
}


static void tile_finalize (GObject* obj) {
	Tile * self;
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TILE, Tile);
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	G_OBJECT_CLASS (tile_parent_class)->finalize (obj);
#line 395 "game.c"
}


/**
 *  This is the model layer of a tile.
 */
GType tile_get_type (void) {
	static volatile gsize tile_type_id__volatile = 0;
	if (g_once_init_enter (&tile_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tile_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Tile), 0, (GInstanceInitFunc) tile_instance_init, NULL };
		GType tile_type_id;
		tile_type_id = g_type_register_static (G_TYPE_OBJECT, "Tile", &g_define_type_info, 0);
		g_once_init_leave (&tile_type_id__volatile, tile_type_id);
	}
	return tile_type_id__volatile;
}


static void _vala_tile_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Tile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TILE, Tile);
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	switch (property_id) {
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		case TILE_CLOSED:
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		g_value_set_boolean (value, tile_get_closed (self));
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		break;
#line 425 "game.c"
		default:
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		break;
#line 431 "game.c"
	}
}


static void _vala_tile_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Tile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TILE, Tile);
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	switch (property_id) {
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		case TILE_CLOSED:
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		tile_set_closed (self, g_value_get_boolean (value));
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		break;
#line 447 "game.c"
		default:
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		break;
#line 453 "game.c"
	}
}


Game* game_construct (GType object_type, gint rows, gint columns, gint color_num) {
	Game * self = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	Tile** _tmp5_ = NULL;
#line 99 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self = (Game*) g_object_new (object_type, NULL);
#line 101 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0_ = rows;
#line 101 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self->priv->_rows = _tmp0_;
#line 102 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp1_ = columns;
#line 102 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self->priv->_columns = _tmp1_;
#line 103 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp2_ = color_num;
#line 103 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self->priv->_color_num = _tmp2_;
#line 106 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp3_ = rows;
#line 106 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp4_ = columns;
#line 106 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp5_ = g_new0 (Tile*, (_tmp3_ * _tmp4_) + 1);
#line 106 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self->priv->tiles = (_vala_array_free (self->priv->tiles, self->priv->tiles_length1 * self->priv->tiles_length2, (GDestroyNotify) g_object_unref), NULL);
#line 106 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self->priv->tiles = _tmp5_;
#line 106 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self->priv->tiles_length1 = _tmp3_;
#line 106 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self->priv->tiles_length2 = _tmp4_;
#line 494 "game.c"
	{
		gint x = 0;
#line 108 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		x = 0;
#line 499 "game.c"
		{
			gboolean _tmp6_ = FALSE;
#line 108 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
			_tmp6_ = TRUE;
#line 108 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
			while (TRUE) {
#line 506 "game.c"
				gint _tmp8_ = 0;
				gint _tmp9_ = 0;
#line 108 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				if (!_tmp6_) {
#line 511 "game.c"
					gint _tmp7_ = 0;
#line 108 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_tmp7_ = x;
#line 108 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					x = _tmp7_ + 1;
#line 517 "game.c"
				}
#line 108 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				_tmp6_ = FALSE;
#line 108 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				_tmp8_ = x;
#line 108 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				_tmp9_ = columns;
#line 108 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				if (!(_tmp8_ < _tmp9_)) {
#line 108 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					break;
#line 529 "game.c"
				}
				{
					gint y = 0;
#line 110 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					y = 0;
#line 535 "game.c"
					{
						gboolean _tmp10_ = FALSE;
#line 110 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
						_tmp10_ = TRUE;
#line 110 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
						while (TRUE) {
#line 542 "game.c"
							gint _tmp12_ = 0;
							gint _tmp13_ = 0;
							gint c = 0;
							gdouble _tmp14_ = 0.0;
							gint _tmp15_ = 0;
							gdouble _tmp16_ = 0.0;
							Tile** _tmp17_ = NULL;
							gint _tmp17__length1 = 0;
							gint _tmp17__length2 = 0;
							gint _tmp18_ = 0;
							gint _tmp19_ = 0;
							gint _tmp20_ = 0;
							gint _tmp21_ = 0;
							gint _tmp22_ = 0;
							Tile* _tmp23_ = NULL;
							Tile* _tmp24_ = NULL;
#line 110 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							if (!_tmp10_) {
#line 561 "game.c"
								gint _tmp11_ = 0;
#line 110 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
								_tmp11_ = y;
#line 110 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
								y = _tmp11_ + 1;
#line 567 "game.c"
							}
#line 110 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp10_ = FALSE;
#line 110 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp12_ = y;
#line 110 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp13_ = rows;
#line 110 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							if (!(_tmp12_ < _tmp13_)) {
#line 110 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
								break;
#line 579 "game.c"
							}
#line 112 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp14_ = g_random_double ();
#line 112 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp15_ = color_num;
#line 112 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp16_ = floor (_tmp14_ * _tmp15_);
#line 112 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							c = (gint) _tmp16_;
#line 113 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp17_ = self->priv->tiles;
#line 113 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp17__length1 = self->priv->tiles_length1;
#line 113 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp17__length2 = self->priv->tiles_length2;
#line 113 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp18_ = y;
#line 113 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp19_ = x;
#line 113 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp20_ = x;
#line 113 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp21_ = y;
#line 113 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp22_ = c;
#line 113 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp23_ = tile_new (_tmp20_, _tmp21_, _tmp22_);
#line 113 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_g_object_unref0 (_tmp17_[(_tmp18_ * _tmp17__length2) + _tmp19_]);
#line 113 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp17_[(_tmp18_ * _tmp17__length2) + _tmp19_] = _tmp23_;
#line 113 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp24_ = _tmp17_[(_tmp18_ * _tmp17__length2) + _tmp19_];
#line 613 "game.c"
						}
					}
				}
			}
		}
	}
#line 117 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self->priv->is_started = FALSE;
#line 99 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	return self;
#line 624 "game.c"
}


Game* game_new (gint rows, gint columns, gint color_num) {
#line 99 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	return game_construct (TYPE_GAME, rows, columns, color_num);
#line 631 "game.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 133 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	return self ? g_object_ref (self) : NULL;
#line 638 "game.c"
}


static void _g_object_unref0_ (gpointer var) {
#line 121 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 645 "game.c"
}


static void _g_list_free__g_object_unref0_ (GList* self) {
#line 121 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_list_foreach (self, (GFunc) _g_object_unref0_, NULL);
#line 121 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_list_free (self);
#line 654 "game.c"
}


static GList* _game_connected_tiles (Game* self, Tile* li) {
	GList* result = NULL;
	GList* cl = NULL;
	gboolean _tmp0_ = FALSE;
	Tile* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gint x = 0;
	Tile* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gint y = 0;
	Tile* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	Tile* _tmp10_ = NULL;
	Tile* _tmp11_ = NULL;
	Tile* _tmp12_ = NULL;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	gint _tmp15_ = 0;
	gint _tmp16_ = 0;
	gboolean _tmp33_ = FALSE;
	gboolean _tmp34_ = FALSE;
	gint _tmp35_ = 0;
	gboolean _tmp52_ = FALSE;
	gboolean _tmp53_ = FALSE;
	gint _tmp54_ = 0;
	gint _tmp55_ = 0;
	gboolean _tmp72_ = FALSE;
	gboolean _tmp73_ = FALSE;
	gint _tmp74_ = 0;
#line 121 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 123 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	cl = NULL;
#line 125 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp1_ = li;
#line 125 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp2_ = _tmp1_->visited;
#line 125 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if (_tmp2_) {
#line 125 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp0_ = TRUE;
#line 699 "game.c"
	} else {
		Tile* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
#line 125 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp3_ = li;
#line 125 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp4_ = tile_get_closed (_tmp3_);
#line 125 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp5_ = _tmp4_;
#line 125 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp0_ = _tmp5_;
#line 712 "game.c"
	}
#line 125 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if (_tmp0_) {
#line 126 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		result = cl;
#line 126 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		return result;
#line 720 "game.c"
	}
#line 128 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp6_ = li;
#line 128 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp7_ = _tmp6_->grid_x;
#line 128 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	x = _tmp7_;
#line 129 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp8_ = li;
#line 129 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp9_ = _tmp8_->grid_y;
#line 129 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	y = _tmp9_;
#line 131 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp10_ = li;
#line 131 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp10_->visited = TRUE;
#line 133 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp11_ = li;
#line 133 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 133 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	cl = g_list_append (cl, _tmp12_);
#line 135 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp15_ = y;
#line 135 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp16_ = self->priv->_rows;
#line 135 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if ((_tmp15_ + 1) < _tmp16_) {
#line 750 "game.c"
		Tile** _tmp17_ = NULL;
		gint _tmp17__length1 = 0;
		gint _tmp17__length2 = 0;
		gint _tmp18_ = 0;
		gint _tmp19_ = 0;
		Tile* _tmp20_ = NULL;
#line 135 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp17_ = self->priv->tiles;
#line 135 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp17__length1 = self->priv->tiles_length1;
#line 135 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp17__length2 = self->priv->tiles_length2;
#line 135 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp18_ = y;
#line 135 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp19_ = x;
#line 135 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp20_ = _tmp17_[((_tmp18_ + 1) * _tmp17__length2) + _tmp19_];
#line 135 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp14_ = _tmp20_ != NULL;
#line 771 "game.c"
	} else {
#line 135 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp14_ = FALSE;
#line 775 "game.c"
	}
#line 135 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if (_tmp14_) {
#line 779 "game.c"
		Tile* _tmp21_ = NULL;
		gint _tmp22_ = 0;
		Tile** _tmp23_ = NULL;
		gint _tmp23__length1 = 0;
		gint _tmp23__length2 = 0;
		gint _tmp24_ = 0;
		gint _tmp25_ = 0;
		Tile* _tmp26_ = NULL;
		gint _tmp27_ = 0;
#line 135 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp21_ = li;
#line 135 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp22_ = _tmp21_->color;
#line 135 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp23_ = self->priv->tiles;
#line 135 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp23__length1 = self->priv->tiles_length1;
#line 135 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp23__length2 = self->priv->tiles_length2;
#line 135 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp24_ = y;
#line 135 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp25_ = x;
#line 135 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp26_ = _tmp23_[((_tmp24_ + 1) * _tmp23__length2) + _tmp25_];
#line 135 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp27_ = _tmp26_->color;
#line 135 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp13_ = _tmp22_ == _tmp27_;
#line 809 "game.c"
	} else {
#line 135 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp13_ = FALSE;
#line 813 "game.c"
	}
#line 135 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if (_tmp13_) {
#line 817 "game.c"
		Tile** _tmp28_ = NULL;
		gint _tmp28__length1 = 0;
		gint _tmp28__length2 = 0;
		gint _tmp29_ = 0;
		gint _tmp30_ = 0;
		Tile* _tmp31_ = NULL;
		GList* _tmp32_ = NULL;
#line 136 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp28_ = self->priv->tiles;
#line 136 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp28__length1 = self->priv->tiles_length1;
#line 136 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp28__length2 = self->priv->tiles_length2;
#line 136 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp29_ = y;
#line 136 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp30_ = x;
#line 136 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp31_ = _tmp28_[((_tmp29_ + 1) * _tmp28__length2) + _tmp30_];
#line 136 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp32_ = _game_connected_tiles (self, _tmp31_);
#line 136 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		cl = g_list_concat (cl, _tmp32_);
#line 841 "game.c"
	}
#line 138 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp35_ = y;
#line 138 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if ((_tmp35_ - 1) >= 0) {
#line 847 "game.c"
		Tile** _tmp36_ = NULL;
		gint _tmp36__length1 = 0;
		gint _tmp36__length2 = 0;
		gint _tmp37_ = 0;
		gint _tmp38_ = 0;
		Tile* _tmp39_ = NULL;
#line 138 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp36_ = self->priv->tiles;
#line 138 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp36__length1 = self->priv->tiles_length1;
#line 138 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp36__length2 = self->priv->tiles_length2;
#line 138 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp37_ = y;
#line 138 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp38_ = x;
#line 138 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp39_ = _tmp36_[((_tmp37_ - 1) * _tmp36__length2) + _tmp38_];
#line 138 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp34_ = _tmp39_ != NULL;
#line 868 "game.c"
	} else {
#line 138 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp34_ = FALSE;
#line 872 "game.c"
	}
#line 138 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if (_tmp34_) {
#line 876 "game.c"
		Tile* _tmp40_ = NULL;
		gint _tmp41_ = 0;
		Tile** _tmp42_ = NULL;
		gint _tmp42__length1 = 0;
		gint _tmp42__length2 = 0;
		gint _tmp43_ = 0;
		gint _tmp44_ = 0;
		Tile* _tmp45_ = NULL;
		gint _tmp46_ = 0;
#line 138 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp40_ = li;
#line 138 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp41_ = _tmp40_->color;
#line 138 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp42_ = self->priv->tiles;
#line 138 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp42__length1 = self->priv->tiles_length1;
#line 138 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp42__length2 = self->priv->tiles_length2;
#line 138 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp43_ = y;
#line 138 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp44_ = x;
#line 138 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp45_ = _tmp42_[((_tmp43_ - 1) * _tmp42__length2) + _tmp44_];
#line 138 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp46_ = _tmp45_->color;
#line 138 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp33_ = _tmp41_ == _tmp46_;
#line 906 "game.c"
	} else {
#line 138 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp33_ = FALSE;
#line 910 "game.c"
	}
#line 138 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if (_tmp33_) {
#line 914 "game.c"
		Tile** _tmp47_ = NULL;
		gint _tmp47__length1 = 0;
		gint _tmp47__length2 = 0;
		gint _tmp48_ = 0;
		gint _tmp49_ = 0;
		Tile* _tmp50_ = NULL;
		GList* _tmp51_ = NULL;
#line 139 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp47_ = self->priv->tiles;
#line 139 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp47__length1 = self->priv->tiles_length1;
#line 139 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp47__length2 = self->priv->tiles_length2;
#line 139 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp48_ = y;
#line 139 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp49_ = x;
#line 139 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp50_ = _tmp47_[((_tmp48_ - 1) * _tmp47__length2) + _tmp49_];
#line 139 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp51_ = _game_connected_tiles (self, _tmp50_);
#line 139 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		cl = g_list_concat (cl, _tmp51_);
#line 938 "game.c"
	}
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp54_ = x;
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp55_ = self->priv->_columns;
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if ((_tmp54_ + 1) < _tmp55_) {
#line 946 "game.c"
		Tile** _tmp56_ = NULL;
		gint _tmp56__length1 = 0;
		gint _tmp56__length2 = 0;
		gint _tmp57_ = 0;
		gint _tmp58_ = 0;
		Tile* _tmp59_ = NULL;
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp56_ = self->priv->tiles;
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp56__length1 = self->priv->tiles_length1;
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp56__length2 = self->priv->tiles_length2;
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp57_ = y;
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp58_ = x;
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp59_ = _tmp56_[(_tmp57_ * _tmp56__length2) + (_tmp58_ + 1)];
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp53_ = _tmp59_ != NULL;
#line 967 "game.c"
	} else {
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp53_ = FALSE;
#line 971 "game.c"
	}
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if (_tmp53_) {
#line 975 "game.c"
		Tile* _tmp60_ = NULL;
		gint _tmp61_ = 0;
		Tile** _tmp62_ = NULL;
		gint _tmp62__length1 = 0;
		gint _tmp62__length2 = 0;
		gint _tmp63_ = 0;
		gint _tmp64_ = 0;
		Tile* _tmp65_ = NULL;
		gint _tmp66_ = 0;
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp60_ = li;
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp61_ = _tmp60_->color;
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp62_ = self->priv->tiles;
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp62__length1 = self->priv->tiles_length1;
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp62__length2 = self->priv->tiles_length2;
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp63_ = y;
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp64_ = x;
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp65_ = _tmp62_[(_tmp63_ * _tmp62__length2) + (_tmp64_ + 1)];
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp66_ = _tmp65_->color;
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp52_ = _tmp61_ == _tmp66_;
#line 1005 "game.c"
	} else {
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp52_ = FALSE;
#line 1009 "game.c"
	}
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if (_tmp52_) {
#line 1013 "game.c"
		Tile** _tmp67_ = NULL;
		gint _tmp67__length1 = 0;
		gint _tmp67__length2 = 0;
		gint _tmp68_ = 0;
		gint _tmp69_ = 0;
		Tile* _tmp70_ = NULL;
		GList* _tmp71_ = NULL;
#line 142 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp67_ = self->priv->tiles;
#line 142 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp67__length1 = self->priv->tiles_length1;
#line 142 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp67__length2 = self->priv->tiles_length2;
#line 142 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp68_ = y;
#line 142 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp69_ = x;
#line 142 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp70_ = _tmp67_[(_tmp68_ * _tmp67__length2) + (_tmp69_ + 1)];
#line 142 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp71_ = _game_connected_tiles (self, _tmp70_);
#line 142 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		cl = g_list_concat (cl, _tmp71_);
#line 1037 "game.c"
	}
#line 144 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp74_ = x;
#line 144 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if ((_tmp74_ - 1) >= 0) {
#line 1043 "game.c"
		Tile** _tmp75_ = NULL;
		gint _tmp75__length1 = 0;
		gint _tmp75__length2 = 0;
		gint _tmp76_ = 0;
		gint _tmp77_ = 0;
		Tile* _tmp78_ = NULL;
#line 144 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp75_ = self->priv->tiles;
#line 144 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp75__length1 = self->priv->tiles_length1;
#line 144 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp75__length2 = self->priv->tiles_length2;
#line 144 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp76_ = y;
#line 144 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp77_ = x;
#line 144 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp78_ = _tmp75_[(_tmp76_ * _tmp75__length2) + (_tmp77_ - 1)];
#line 144 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp73_ = _tmp78_ != NULL;
#line 1064 "game.c"
	} else {
#line 144 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp73_ = FALSE;
#line 1068 "game.c"
	}
#line 144 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if (_tmp73_) {
#line 1072 "game.c"
		Tile* _tmp79_ = NULL;
		gint _tmp80_ = 0;
		Tile** _tmp81_ = NULL;
		gint _tmp81__length1 = 0;
		gint _tmp81__length2 = 0;
		gint _tmp82_ = 0;
		gint _tmp83_ = 0;
		Tile* _tmp84_ = NULL;
		gint _tmp85_ = 0;
#line 144 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp79_ = li;
#line 144 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp80_ = _tmp79_->color;
#line 144 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp81_ = self->priv->tiles;
#line 144 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp81__length1 = self->priv->tiles_length1;
#line 144 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp81__length2 = self->priv->tiles_length2;
#line 144 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp82_ = y;
#line 144 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp83_ = x;
#line 144 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp84_ = _tmp81_[(_tmp82_ * _tmp81__length2) + (_tmp83_ - 1)];
#line 144 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp85_ = _tmp84_->color;
#line 144 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp72_ = _tmp80_ == _tmp85_;
#line 1102 "game.c"
	} else {
#line 144 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp72_ = FALSE;
#line 1106 "game.c"
	}
#line 144 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if (_tmp72_) {
#line 1110 "game.c"
		Tile** _tmp86_ = NULL;
		gint _tmp86__length1 = 0;
		gint _tmp86__length2 = 0;
		gint _tmp87_ = 0;
		gint _tmp88_ = 0;
		Tile* _tmp89_ = NULL;
		GList* _tmp90_ = NULL;
#line 145 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp86_ = self->priv->tiles;
#line 145 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp86__length1 = self->priv->tiles_length1;
#line 145 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp86__length2 = self->priv->tiles_length2;
#line 145 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp87_ = y;
#line 145 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp88_ = x;
#line 145 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp89_ = _tmp86_[(_tmp87_ * _tmp86__length2) + (_tmp88_ - 1)];
#line 145 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp90_ = _game_connected_tiles (self, _tmp89_);
#line 145 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		cl = g_list_concat (cl, _tmp90_);
#line 1134 "game.c"
	}
#line 147 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	result = cl;
#line 147 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	return result;
#line 1140 "game.c"
}


GList* game_connected_tiles (Game* self, Tile* li) {
	GList* result = NULL;
	Tile** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
	GList* cl = NULL;
	Tile* _tmp4_ = NULL;
	GList* _tmp5_ = NULL;
	GList* _tmp6_ = NULL;
	guint _tmp7_ = 0U;
#line 150 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 150 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_return_val_if_fail (li != NULL, NULL);
#line 152 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0_ = self->priv->tiles;
#line 152 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0__length1 = self->priv->tiles_length1;
#line 152 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0__length2 = self->priv->tiles_length2;
#line 1164 "game.c"
	{
		Tile** l_collection = NULL;
		gint l_collection_length1 = 0;
		gint l_collection_length2 = 0;
		gint l_it = 0;
#line 152 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		l_collection = _tmp0_;
#line 152 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		l_collection_length1 = _tmp0__length1 * _tmp0__length2;
#line 152 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		for (l_it = 0; l_it < (_tmp0__length1 * _tmp0__length2); l_it = l_it + 1) {
#line 1176 "game.c"
			Tile* _tmp1_ = NULL;
			Tile* l = NULL;
#line 152 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
			_tmp1_ = _g_object_ref0 (l_collection[l_it]);
#line 152 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
			l = _tmp1_;
#line 1183 "game.c"
			{
				Tile* _tmp2_ = NULL;
#line 154 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				_tmp2_ = l;
#line 154 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				if (_tmp2_ != NULL) {
#line 1190 "game.c"
					Tile* _tmp3_ = NULL;
#line 155 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_tmp3_ = l;
#line 155 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_tmp3_->visited = FALSE;
#line 1196 "game.c"
				}
#line 152 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				_g_object_unref0 (l);
#line 1200 "game.c"
			}
		}
	}
#line 158 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp4_ = li;
#line 158 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp5_ = _game_connected_tiles (self, _tmp4_);
#line 158 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	cl = _tmp5_;
#line 161 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp6_ = cl;
#line 161 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp7_ = g_list_length (_tmp6_);
#line 161 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if (_tmp7_ < ((guint) 2)) {
#line 162 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		__g_list_free__g_object_unref0_0 (cl);
#line 162 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		cl = NULL;
#line 1220 "game.c"
	}
#line 164 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	result = cl;
#line 164 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	return result;
#line 1226 "game.c"
}


Tile* game_get_tile (Game* self, gint x, gint y) {
	Tile* result = NULL;
	Tile** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	Tile* _tmp3_ = NULL;
	Tile* _tmp4_ = NULL;
#line 167 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 169 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0_ = self->priv->tiles;
#line 169 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0__length1 = self->priv->tiles_length1;
#line 169 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0__length2 = self->priv->tiles_length2;
#line 169 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp1_ = y;
#line 169 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp2_ = x;
#line 169 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp3_ = _tmp0_[(_tmp1_ * _tmp0__length2) + _tmp2_];
#line 169 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 169 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	result = _tmp4_;
#line 169 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	return result;
#line 1259 "game.c"
}


gboolean game_remove_connected_tiles (Game* self, Tile* tile) {
	gboolean result = FALSE;
	GList* cl = NULL;
	Tile* _tmp0_ = NULL;
	GList* _tmp1_ = NULL;
	GList* _tmp2_ = NULL;
	GList* _tmp3_ = NULL;
	gint new_x = 0;
	GList* _tmp70_ = NULL;
	guint _tmp71_ = 0U;
	gboolean _tmp72_ = FALSE;
	gboolean _tmp73_ = FALSE;
#line 172 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 172 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_return_val_if_fail (tile != NULL, FALSE);
#line 174 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0_ = tile;
#line 174 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp1_ = game_connected_tiles (self, _tmp0_);
#line 174 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	cl = _tmp1_;
#line 176 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp2_ = cl;
#line 176 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if (_tmp2_ == NULL) {
#line 177 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		result = FALSE;
#line 177 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		__g_list_free__g_object_unref0_0 (cl);
#line 177 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		return result;
#line 1295 "game.c"
	}
#line 179 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp3_ = cl;
#line 1299 "game.c"
	{
		GList* l_collection = NULL;
		GList* l_it = NULL;
#line 179 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		l_collection = _tmp3_;
#line 179 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		for (l_it = l_collection; l_it != NULL; l_it = l_it->next) {
#line 1307 "game.c"
			Tile* _tmp4_ = NULL;
			Tile* l = NULL;
#line 179 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
			_tmp4_ = _g_object_ref0 ((Tile*) l_it->data);
#line 179 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
			l = _tmp4_;
#line 1314 "game.c"
			{
				Tile* _tmp5_ = NULL;
#line 180 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				_tmp5_ = l;
#line 180 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				tile_set_closed (_tmp5_, TRUE);
#line 179 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				_g_object_unref0 (l);
#line 1323 "game.c"
			}
		}
	}
#line 182 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	new_x = 0;
#line 1329 "game.c"
	{
		gint x = 0;
#line 184 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		x = 0;
#line 1334 "game.c"
		{
			gboolean _tmp6_ = FALSE;
#line 184 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
			_tmp6_ = TRUE;
#line 184 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
			while (TRUE) {
#line 1341 "game.c"
				gint _tmp8_ = 0;
				gint _tmp9_ = 0;
				GList* not_closed_tiles = NULL;
				GList* closed_tiles = NULL;
				GList* _tmp27_ = NULL;
				gboolean has_empty_col = FALSE;
				gboolean _tmp56_ = FALSE;
#line 184 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				if (!_tmp6_) {
#line 1351 "game.c"
					gint _tmp7_ = 0;
#line 184 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_tmp7_ = x;
#line 184 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					x = _tmp7_ + 1;
#line 1357 "game.c"
				}
#line 184 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				_tmp6_ = FALSE;
#line 184 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				_tmp8_ = x;
#line 184 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				_tmp9_ = self->priv->_columns;
#line 184 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				if (!(_tmp8_ < _tmp9_)) {
#line 184 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					break;
#line 1369 "game.c"
				}
#line 186 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				not_closed_tiles = NULL;
#line 187 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				closed_tiles = NULL;
#line 1375 "game.c"
				{
					gint y = 0;
#line 190 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					y = 0;
#line 1380 "game.c"
					{
						gboolean _tmp10_ = FALSE;
#line 190 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
						_tmp10_ = TRUE;
#line 190 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
						while (TRUE) {
#line 1387 "game.c"
							gint _tmp12_ = 0;
							gint _tmp13_ = 0;
							Tile* li = NULL;
							Tile** _tmp14_ = NULL;
							gint _tmp14__length1 = 0;
							gint _tmp14__length2 = 0;
							gint _tmp15_ = 0;
							gint _tmp16_ = 0;
							Tile* _tmp17_ = NULL;
							Tile* _tmp18_ = NULL;
							Tile* _tmp19_ = NULL;
							Tile* _tmp20_ = NULL;
							gboolean _tmp21_ = FALSE;
							gboolean _tmp22_ = FALSE;
#line 190 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							if (!_tmp10_) {
#line 1404 "game.c"
								gint _tmp11_ = 0;
#line 190 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
								_tmp11_ = y;
#line 190 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
								y = _tmp11_ + 1;
#line 1410 "game.c"
							}
#line 190 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp10_ = FALSE;
#line 190 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp12_ = y;
#line 190 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp13_ = self->priv->_rows;
#line 190 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							if (!(_tmp12_ < _tmp13_)) {
#line 190 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
								break;
#line 1422 "game.c"
							}
#line 192 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp14_ = self->priv->tiles;
#line 192 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp14__length1 = self->priv->tiles_length1;
#line 192 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp14__length2 = self->priv->tiles_length2;
#line 192 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp15_ = y;
#line 192 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp16_ = x;
#line 192 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp17_ = _tmp14_[(_tmp15_ * _tmp14__length2) + _tmp16_];
#line 192 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp18_ = _g_object_ref0 (_tmp17_);
#line 192 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							li = _tmp18_;
#line 194 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp19_ = li;
#line 194 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							if (_tmp19_ == NULL) {
#line 195 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
								_g_object_unref0 (li);
#line 195 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
								break;
#line 1448 "game.c"
							}
#line 197 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp20_ = li;
#line 197 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp21_ = tile_get_closed (_tmp20_);
#line 197 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp22_ = _tmp21_;
#line 197 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							if (_tmp22_) {
#line 1458 "game.c"
								Tile* _tmp23_ = NULL;
								Tile* _tmp24_ = NULL;
#line 198 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
								_tmp23_ = li;
#line 198 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
								_tmp24_ = _g_object_ref0 (_tmp23_);
#line 198 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
								closed_tiles = g_list_append (closed_tiles, _tmp24_);
#line 1467 "game.c"
							} else {
								Tile* _tmp25_ = NULL;
								Tile* _tmp26_ = NULL;
#line 200 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
								_tmp25_ = li;
#line 200 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
								_tmp26_ = _g_object_ref0 (_tmp25_);
#line 200 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
								not_closed_tiles = g_list_append (not_closed_tiles, _tmp26_);
#line 1477 "game.c"
							}
#line 190 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_g_object_unref0 (li);
#line 1481 "game.c"
						}
					}
				}
#line 204 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				_tmp27_ = closed_tiles;
#line 204 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				closed_tiles = NULL;
#line 204 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				not_closed_tiles = g_list_concat (not_closed_tiles, _tmp27_);
#line 1491 "game.c"
				{
					gint y = 0;
#line 207 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					y = 0;
#line 1496 "game.c"
					{
						gboolean _tmp28_ = FALSE;
#line 207 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
						_tmp28_ = TRUE;
#line 207 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
						while (TRUE) {
#line 1503 "game.c"
							gint _tmp30_ = 0;
							gint _tmp31_ = 0;
							Tile** _tmp32_ = NULL;
							gint _tmp32__length1 = 0;
							gint _tmp32__length2 = 0;
							gint _tmp33_ = 0;
							gint _tmp34_ = 0;
							GList* _tmp35_ = NULL;
							gint _tmp36_ = 0;
							gconstpointer _tmp37_ = NULL;
							Tile* _tmp38_ = NULL;
							Tile* _tmp39_ = NULL;
#line 207 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							if (!_tmp28_) {
#line 1518 "game.c"
								gint _tmp29_ = 0;
#line 207 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
								_tmp29_ = y;
#line 207 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
								y = _tmp29_ + 1;
#line 1524 "game.c"
							}
#line 207 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp28_ = FALSE;
#line 207 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp30_ = y;
#line 207 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp31_ = self->priv->_rows;
#line 207 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							if (!(_tmp30_ < _tmp31_)) {
#line 207 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
								break;
#line 1536 "game.c"
							}
#line 208 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp32_ = self->priv->tiles;
#line 208 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp32__length1 = self->priv->tiles_length1;
#line 208 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp32__length2 = self->priv->tiles_length2;
#line 208 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp33_ = y;
#line 208 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp34_ = new_x;
#line 208 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp35_ = not_closed_tiles;
#line 208 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp36_ = y;
#line 208 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp37_ = g_list_nth_data (_tmp35_, (guint) _tmp36_);
#line 208 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp38_ = _g_object_ref0 ((Tile*) _tmp37_);
#line 208 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_g_object_unref0 (_tmp32_[(_tmp33_ * _tmp32__length2) + _tmp34_]);
#line 208 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp32_[(_tmp33_ * _tmp32__length2) + _tmp34_] = _tmp38_;
#line 208 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp39_ = _tmp32_[(_tmp33_ * _tmp32__length2) + _tmp34_];
#line 1562 "game.c"
						}
					}
				}
#line 211 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				has_empty_col = TRUE;
#line 1568 "game.c"
				{
					gint y = 0;
#line 214 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					y = 0;
#line 1573 "game.c"
					{
						gboolean _tmp40_ = FALSE;
#line 214 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
						_tmp40_ = TRUE;
#line 214 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
						while (TRUE) {
#line 1580 "game.c"
							gint _tmp42_ = 0;
							gint _tmp43_ = 0;
							Tile* l = NULL;
							Tile** _tmp44_ = NULL;
							gint _tmp44__length1 = 0;
							gint _tmp44__length2 = 0;
							gint _tmp45_ = 0;
							gint _tmp46_ = 0;
							Tile* _tmp47_ = NULL;
							Tile* _tmp48_ = NULL;
							Tile* _tmp49_ = NULL;
							Tile* _tmp50_ = NULL;
							gint _tmp51_ = 0;
							gint _tmp52_ = 0;
							Tile* _tmp53_ = NULL;
							gboolean _tmp54_ = FALSE;
							gboolean _tmp55_ = FALSE;
#line 214 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							if (!_tmp40_) {
#line 1600 "game.c"
								gint _tmp41_ = 0;
#line 214 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
								_tmp41_ = y;
#line 214 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
								y = _tmp41_ + 1;
#line 1606 "game.c"
							}
#line 214 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp40_ = FALSE;
#line 214 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp42_ = y;
#line 214 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp43_ = self->priv->_rows;
#line 214 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							if (!(_tmp42_ < _tmp43_)) {
#line 214 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
								break;
#line 1618 "game.c"
							}
#line 216 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp44_ = self->priv->tiles;
#line 216 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp44__length1 = self->priv->tiles_length1;
#line 216 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp44__length2 = self->priv->tiles_length2;
#line 216 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp45_ = y;
#line 216 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp46_ = new_x;
#line 216 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp47_ = _tmp44_[(_tmp45_ * _tmp44__length2) + _tmp46_];
#line 216 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp48_ = _g_object_ref0 (_tmp47_);
#line 216 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							l = _tmp48_;
#line 218 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp49_ = l;
#line 218 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							if (_tmp49_ == NULL) {
#line 219 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
								_g_object_unref0 (l);
#line 219 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
								break;
#line 1644 "game.c"
							}
#line 221 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp50_ = l;
#line 221 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp51_ = new_x;
#line 221 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp52_ = y;
#line 221 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							tile_update_position (_tmp50_, _tmp51_, _tmp52_);
#line 223 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp53_ = l;
#line 223 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp54_ = tile_get_closed (_tmp53_);
#line 223 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp55_ = _tmp54_;
#line 223 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							if (!_tmp55_) {
#line 224 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
								has_empty_col = FALSE;
#line 1664 "game.c"
							}
#line 214 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_g_object_unref0 (l);
#line 1668 "game.c"
						}
					}
				}
#line 228 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				_tmp56_ = has_empty_col;
#line 228 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				if (!_tmp56_) {
#line 1676 "game.c"
					gint _tmp57_ = 0;
#line 229 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_tmp57_ = new_x;
#line 229 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					new_x = _tmp57_ + 1;
#line 1682 "game.c"
				}
#line 184 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				__g_list_free__g_object_unref0_0 (closed_tiles);
#line 184 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				__g_list_free__g_object_unref0_0 (not_closed_tiles);
#line 1688 "game.c"
			}
		}
	}
	{
		gboolean _tmp58_ = FALSE;
#line 233 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp58_ = TRUE;
#line 233 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		while (TRUE) {
#line 1698 "game.c"
			gint _tmp60_ = 0;
			gint _tmp61_ = 0;
#line 233 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
			if (!_tmp58_) {
#line 1703 "game.c"
				gint _tmp59_ = 0;
#line 233 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				_tmp59_ = new_x;
#line 233 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				new_x = _tmp59_ + 1;
#line 1709 "game.c"
			}
#line 233 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
			_tmp58_ = FALSE;
#line 233 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
			_tmp60_ = new_x;
#line 233 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
			_tmp61_ = self->priv->_columns;
#line 233 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
			if (!(_tmp60_ < _tmp61_)) {
#line 233 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				break;
#line 1721 "game.c"
			}
			{
				gint y = 0;
#line 234 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				y = 0;
#line 1727 "game.c"
				{
					gboolean _tmp62_ = FALSE;
#line 234 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_tmp62_ = TRUE;
#line 234 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					while (TRUE) {
#line 1734 "game.c"
						gint _tmp64_ = 0;
						gint _tmp65_ = 0;
						Tile** _tmp66_ = NULL;
						gint _tmp66__length1 = 0;
						gint _tmp66__length2 = 0;
						gint _tmp67_ = 0;
						gint _tmp68_ = 0;
						Tile* _tmp69_ = NULL;
#line 234 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
						if (!_tmp62_) {
#line 1745 "game.c"
							gint _tmp63_ = 0;
#line 234 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							_tmp63_ = y;
#line 234 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							y = _tmp63_ + 1;
#line 1751 "game.c"
						}
#line 234 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
						_tmp62_ = FALSE;
#line 234 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
						_tmp64_ = y;
#line 234 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
						_tmp65_ = self->priv->_rows;
#line 234 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
						if (!(_tmp64_ < _tmp65_)) {
#line 234 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
							break;
#line 1763 "game.c"
						}
#line 235 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
						_tmp66_ = self->priv->tiles;
#line 235 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
						_tmp66__length1 = self->priv->tiles_length1;
#line 235 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
						_tmp66__length2 = self->priv->tiles_length2;
#line 235 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
						_tmp67_ = y;
#line 235 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
						_tmp68_ = new_x;
#line 235 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
						_g_object_unref0 (_tmp66_[(_tmp67_ * _tmp66__length2) + _tmp68_]);
#line 235 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
						_tmp66_[(_tmp67_ * _tmp66__length2) + _tmp68_] = NULL;
#line 235 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
						_tmp69_ = _tmp66_[(_tmp67_ * _tmp66__length2) + _tmp68_];
#line 1781 "game.c"
					}
				}
			}
		}
	}
#line 237 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp70_ = cl;
#line 237 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp71_ = g_list_length (_tmp70_);
#line 237 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	game_increment_score_from_tiles (self, (gint) _tmp71_);
#line 239 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp72_ = self->priv->is_started;
#line 239 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if (!_tmp72_) {
#line 240 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		self->priv->is_started = TRUE;
#line 241 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		g_signal_emit_by_name (self, "started");
#line 1801 "game.c"
	}
#line 244 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp73_ = game_has_completed (self);
#line 244 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if (_tmp73_) {
#line 1807 "game.c"
		gboolean _tmp74_ = FALSE;
#line 246 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp74_ = game_has_won (self);
#line 246 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		if (_tmp74_) {
#line 247 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
			game_increment_score (self, 1000);
#line 1815 "game.c"
		}
#line 248 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		g_signal_emit_by_name (self, "complete");
#line 1819 "game.c"
	}
#line 251 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	result = FALSE;
#line 251 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	__g_list_free__g_object_unref0_0 (cl);
#line 251 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	return result;
#line 1827 "game.c"
}


void game_reset_visit (Game* self) {
	Tile** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
#line 254 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_return_if_fail (self != NULL);
#line 256 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0_ = self->priv->tiles;
#line 256 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0__length1 = self->priv->tiles_length1;
#line 256 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0__length2 = self->priv->tiles_length2;
#line 1843 "game.c"
	{
		Tile** l_collection = NULL;
		gint l_collection_length1 = 0;
		gint l_collection_length2 = 0;
		gint l_it = 0;
#line 256 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		l_collection = _tmp0_;
#line 256 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		l_collection_length1 = _tmp0__length1 * _tmp0__length2;
#line 256 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		for (l_it = 0; l_it < (_tmp0__length1 * _tmp0__length2); l_it = l_it + 1) {
#line 1855 "game.c"
			Tile* _tmp1_ = NULL;
			Tile* l = NULL;
#line 256 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
			_tmp1_ = _g_object_ref0 (l_collection[l_it]);
#line 256 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
			l = _tmp1_;
#line 1862 "game.c"
			{
				Tile* _tmp2_ = NULL;
#line 258 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				_tmp2_ = l;
#line 258 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				if (_tmp2_ != NULL) {
#line 1869 "game.c"
					Tile* _tmp3_ = NULL;
#line 259 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_tmp3_ = l;
#line 259 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_tmp3_->visited = FALSE;
#line 1875 "game.c"
				}
#line 256 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				_g_object_unref0 (l);
#line 1879 "game.c"
			}
		}
	}
}


gboolean game_has_completed (Game* self) {
	gboolean result = FALSE;
	Tile** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
#line 263 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 265 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0_ = self->priv->tiles;
#line 265 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0__length1 = self->priv->tiles_length1;
#line 265 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0__length2 = self->priv->tiles_length2;
#line 1899 "game.c"
	{
		Tile** l_collection = NULL;
		gint l_collection_length1 = 0;
		gint l_collection_length2 = 0;
		gint l_it = 0;
#line 265 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		l_collection = _tmp0_;
#line 265 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		l_collection_length1 = _tmp0__length1 * _tmp0__length2;
#line 265 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		for (l_it = 0; l_it < (_tmp0__length1 * _tmp0__length2); l_it = l_it + 1) {
#line 1911 "game.c"
			Tile* _tmp1_ = NULL;
			Tile* l = NULL;
#line 265 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
			_tmp1_ = _g_object_ref0 (l_collection[l_it]);
#line 265 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
			l = _tmp1_;
#line 1918 "game.c"
			{
				gboolean _tmp2_ = FALSE;
				gboolean _tmp3_ = FALSE;
				Tile* _tmp4_ = NULL;
#line 267 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				_tmp4_ = l;
#line 267 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				if (_tmp4_ != NULL) {
#line 1927 "game.c"
					Tile* _tmp5_ = NULL;
					gboolean _tmp6_ = FALSE;
					gboolean _tmp7_ = FALSE;
#line 267 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_tmp5_ = l;
#line 267 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_tmp6_ = tile_get_closed (_tmp5_);
#line 267 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_tmp7_ = _tmp6_;
#line 267 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_tmp3_ = !_tmp7_;
#line 1939 "game.c"
				} else {
#line 267 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_tmp3_ = FALSE;
#line 1943 "game.c"
				}
#line 267 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				if (_tmp3_) {
#line 1947 "game.c"
					Tile* _tmp8_ = NULL;
					GList* _tmp9_ = NULL;
					GList* _tmp10_ = NULL;
					guint _tmp11_ = 0U;
#line 267 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_tmp8_ = l;
#line 267 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_tmp9_ = game_connected_tiles (self, _tmp8_);
#line 267 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_tmp10_ = _tmp9_;
#line 267 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_tmp11_ = g_list_length (_tmp10_);
#line 267 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_tmp2_ = _tmp11_ > ((guint) 1);
#line 267 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					__g_list_free__g_object_unref0_0 (_tmp10_);
#line 1964 "game.c"
				} else {
#line 267 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_tmp2_ = FALSE;
#line 1968 "game.c"
				}
#line 267 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				if (_tmp2_) {
#line 268 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					result = FALSE;
#line 268 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_g_object_unref0 (l);
#line 268 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					return result;
#line 1978 "game.c"
				}
#line 265 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				_g_object_unref0 (l);
#line 1982 "game.c"
			}
		}
	}
#line 271 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	result = TRUE;
#line 271 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	return result;
#line 1990 "game.c"
}


gboolean game_has_won (Game* self) {
	gboolean result = FALSE;
	Tile** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp0__length2 = 0;
#line 274 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 276 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0_ = self->priv->tiles;
#line 276 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0__length1 = self->priv->tiles_length1;
#line 276 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0__length2 = self->priv->tiles_length2;
#line 2007 "game.c"
	{
		Tile** l_collection = NULL;
		gint l_collection_length1 = 0;
		gint l_collection_length2 = 0;
		gint l_it = 0;
#line 276 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		l_collection = _tmp0_;
#line 276 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		l_collection_length1 = _tmp0__length1 * _tmp0__length2;
#line 276 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		for (l_it = 0; l_it < (_tmp0__length1 * _tmp0__length2); l_it = l_it + 1) {
#line 2019 "game.c"
			Tile* _tmp1_ = NULL;
			Tile* l = NULL;
#line 276 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
			_tmp1_ = _g_object_ref0 (l_collection[l_it]);
#line 276 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
			l = _tmp1_;
#line 2026 "game.c"
			{
				gboolean _tmp2_ = FALSE;
				Tile* _tmp3_ = NULL;
#line 278 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				_tmp3_ = l;
#line 278 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				if (_tmp3_ != NULL) {
#line 2034 "game.c"
					Tile* _tmp4_ = NULL;
					gboolean _tmp5_ = FALSE;
					gboolean _tmp6_ = FALSE;
#line 278 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_tmp4_ = l;
#line 278 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_tmp5_ = tile_get_closed (_tmp4_);
#line 278 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_tmp6_ = _tmp5_;
#line 278 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_tmp2_ = !_tmp6_;
#line 2046 "game.c"
				} else {
#line 278 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_tmp2_ = FALSE;
#line 2050 "game.c"
				}
#line 278 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				if (_tmp2_) {
#line 279 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					result = FALSE;
#line 279 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					_g_object_unref0 (l);
#line 279 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
					return result;
#line 2060 "game.c"
				}
#line 276 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
				_g_object_unref0 (l);
#line 2064 "game.c"
			}
		}
	}
#line 282 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	result = TRUE;
#line 282 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	return result;
#line 2072 "game.c"
}


void game_increment_score_from_tiles (Game* self, gint n_tiles) {
	gint points_awarded = 0;
	gint _tmp0_ = 0;
	gint _tmp3_ = 0;
#line 285 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_return_if_fail (self != NULL);
#line 287 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	points_awarded = 0;
#line 289 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0_ = n_tiles;
#line 289 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if (_tmp0_ >= 3) {
#line 2088 "game.c"
		gint _tmp1_ = 0;
		gint _tmp2_ = 0;
#line 290 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp1_ = n_tiles;
#line 290 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp2_ = n_tiles;
#line 290 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		points_awarded = (_tmp1_ - 2) * (_tmp2_ - 2);
#line 2097 "game.c"
	}
#line 292 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp3_ = points_awarded;
#line 292 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	game_increment_score (self, _tmp3_);
#line 2103 "game.c"
}


void game_increment_score (Game* self, gint increment) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
#line 295 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_return_if_fail (self != NULL);
#line 297 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0_ = self->priv->_score;
#line 297 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp1_ = increment;
#line 297 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	game_set_score (self, _tmp0_ + _tmp1_);
#line 298 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp2_ = increment;
#line 298 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_signal_emit_by_name (self, "update-score", _tmp2_);
#line 2123 "game.c"
}


gint game_get_score (Game* self) {
	gint result;
	gint _tmp0_ = 0;
#line 75 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 75 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0_ = self->priv->_score;
#line 75 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	result = _tmp0_;
#line 75 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	return result;
#line 2138 "game.c"
}


void game_set_score (Game* self, gint value) {
	gint _tmp0_ = 0;
#line 75 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_return_if_fail (self != NULL);
#line 75 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0_ = value;
#line 75 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self->priv->_score = _tmp0_;
#line 75 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_object_notify ((GObject *) self, "score");
#line 2152 "game.c"
}


gint game_get_color_num (Game* self) {
	gint result;
	gint _tmp0_ = 0;
#line 80 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 80 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0_ = self->priv->_color_num;
#line 80 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	result = _tmp0_;
#line 80 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	return result;
#line 2167 "game.c"
}


void game_set_color_num (Game* self, gint value) {
	gboolean _tmp0_ = FALSE;
	gint _tmp1_ = 0;
#line 81 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_return_if_fail (self != NULL);
#line 83 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp1_ = value;
#line 83 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if (_tmp1_ < 2) {
#line 83 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp0_ = TRUE;
#line 2182 "game.c"
	} else {
		gint _tmp2_ = 0;
#line 83 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp2_ = value;
#line 83 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp0_ = _tmp2_ > 4;
#line 2189 "game.c"
	}
#line 83 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	if (_tmp0_) {
#line 84 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		self->priv->_color_num = 3;
#line 2195 "game.c"
	} else {
		gint _tmp3_ = 0;
#line 86 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		_tmp3_ = value;
#line 86 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		self->priv->_color_num = _tmp3_;
#line 2202 "game.c"
	}
#line 81 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_object_notify ((GObject *) self, "color-num");
#line 2206 "game.c"
}


gint game_get_rows (Game* self) {
	gint result;
	gint _tmp0_ = 0;
#line 91 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 91 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0_ = self->priv->_rows;
#line 91 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	result = _tmp0_;
#line 91 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	return result;
#line 2221 "game.c"
}


void game_set_rows (Game* self, gint value) {
	gint _tmp0_ = 0;
#line 91 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_return_if_fail (self != NULL);
#line 91 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0_ = value;
#line 91 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self->priv->_rows = _tmp0_;
#line 91 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_object_notify ((GObject *) self, "rows");
#line 2235 "game.c"
}


gint game_get_columns (Game* self) {
	gint result;
	gint _tmp0_ = 0;
#line 92 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 92 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0_ = self->priv->_columns;
#line 92 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	result = _tmp0_;
#line 92 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	return result;
#line 2250 "game.c"
}


void game_set_columns (Game* self, gint value) {
	gint _tmp0_ = 0;
#line 92 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_return_if_fail (self != NULL);
#line 92 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	_tmp0_ = value;
#line 92 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self->priv->_columns = _tmp0_;
#line 92 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_object_notify ((GObject *) self, "columns");
#line 2264 "game.c"
}


static void game_class_init (GameClass * klass) {
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	game_parent_class = g_type_class_peek_parent (klass);
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_type_class_add_private (klass, sizeof (GamePrivate));
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_get_property;
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_set_property;
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	G_OBJECT_CLASS (klass)->finalize = game_finalize;
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_SCORE, g_param_spec_int ("score", "score", "score", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_COLOR_NUM, g_param_spec_int ("color-num", "color-num", "color-num", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_ROWS, g_param_spec_int ("rows", "rows", "rows", G_MININT, G_MAXINT, 8, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_COLUMNS, g_param_spec_int ("columns", "columns", "columns", G_MININT, G_MAXINT, 8, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_signal_new ("update_score", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_signal_new ("complete", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	g_signal_new ("started", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2293 "game.c"
}


static void game_instance_init (Game * self) {
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self->priv = GAME_GET_PRIVATE (self);
#line 72 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self->priv->is_started = FALSE;
#line 75 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self->priv->_score = 0;
#line 77 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self->priv->_color_num = 3;
#line 91 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self->priv->_rows = 8;
#line 92 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self->priv->_columns = 8;
#line 2310 "game.c"
}


static void game_finalize (GObject* obj) {
	Game * self;
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
#line 71 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	self->priv->tiles = (_vala_array_free (self->priv->tiles, self->priv->tiles_length1 * self->priv->tiles_length2, (GDestroyNotify) g_object_unref), NULL);
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	G_OBJECT_CLASS (game_parent_class)->finalize (obj);
#line 2322 "game.c"
}


/**
 *  This is the model layer of the whole game. All game logic goes here. This class tries not to
 *  bring in any visual stuff to comply the separation of view-model idea.
 */
GType game_get_type (void) {
	static volatile gsize game_type_id__volatile = 0;
	if (g_once_init_enter (&game_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Game), 0, (GInstanceInitFunc) game_instance_init, NULL };
		GType game_type_id;
		game_type_id = g_type_register_static (G_TYPE_OBJECT, "Game", &g_define_type_info, 0);
		g_once_init_leave (&game_type_id__volatile, game_type_id);
	}
	return game_type_id__volatile;
}


static void _vala_game_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	switch (property_id) {
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		case GAME_SCORE:
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		g_value_set_int (value, game_get_score (self));
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		break;
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		case GAME_COLOR_NUM:
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		g_value_set_int (value, game_get_color_num (self));
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		break;
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		case GAME_ROWS:
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		g_value_set_int (value, game_get_rows (self));
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		break;
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		case GAME_COLUMNS:
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		g_value_set_int (value, game_get_columns (self));
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		break;
#line 2371 "game.c"
		default:
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		break;
#line 2377 "game.c"
	}
}


static void _vala_game_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
	switch (property_id) {
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		case GAME_SCORE:
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		game_set_score (self, g_value_get_int (value));
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		break;
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		case GAME_COLOR_NUM:
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		game_set_color_num (self, g_value_get_int (value));
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		break;
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		case GAME_ROWS:
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		game_set_rows (self, g_value_get_int (value));
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		break;
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		case GAME_COLUMNS:
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		game_set_columns (self, g_value_get_int (value));
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		break;
#line 2411 "game.c"
		default:
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/game.vala"
		break;
#line 2417 "game.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



