/* score-dialog.c generated by valac 0.29.2.13-e9504, the Vala compiler
 * generated from score-dialog.vala, do not modify */

/*
 * Copyright (C) 2010-2013 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 2 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>


#define TYPE_SCORE_DIALOG (score_dialog_get_type ())
#define SCORE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SCORE_DIALOG, ScoreDialog))
#define SCORE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SCORE_DIALOG, ScoreDialogClass))
#define IS_SCORE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SCORE_DIALOG))
#define IS_SCORE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SCORE_DIALOG))
#define SCORE_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SCORE_DIALOG, ScoreDialogClass))

typedef struct _ScoreDialog ScoreDialog;
typedef struct _ScoreDialogClass ScoreDialogClass;
typedef struct _ScoreDialogPrivate ScoreDialogPrivate;

#define TYPE_HISTORY (history_get_type ())
#define HISTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HISTORY, History))
#define HISTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HISTORY, HistoryClass))
#define IS_HISTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HISTORY))
#define IS_HISTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HISTORY))
#define HISTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HISTORY, HistoryClass))

typedef struct _History History;
typedef struct _HistoryClass HistoryClass;

#define TYPE_HISTORY_ENTRY (history_entry_get_type ())
#define HISTORY_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HISTORY_ENTRY, HistoryEntry))
#define HISTORY_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HISTORY_ENTRY, HistoryEntryClass))
#define IS_HISTORY_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HISTORY_ENTRY))
#define IS_HISTORY_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HISTORY_ENTRY))
#define HISTORY_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HISTORY_ENTRY, HistoryEntryClass))

typedef struct _HistoryEntry HistoryEntry;
typedef struct _HistoryEntryClass HistoryEntryClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _HistoryPrivate HistoryPrivate;
typedef struct _HistoryEntryPrivate HistoryEntryPrivate;
#define _gtk_tree_path_free0(var) ((var == NULL) ? NULL : (var = (gtk_tree_path_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))

struct _ScoreDialog {
	GtkDialog parent_instance;
	ScoreDialogPrivate * priv;
};

struct _ScoreDialogClass {
	GtkDialogClass parent_class;
};

struct _ScoreDialogPrivate {
	History* history;
	HistoryEntry* selected_entry;
	GtkListStore* size_model;
	GtkListStore* score_model;
	GtkComboBox* size_combo;
	GtkTreeView* scores;
};

struct _History {
	GObject parent_instance;
	HistoryPrivate * priv;
	gchar* filename;
	GList* entries;
};

struct _HistoryClass {
	GObjectClass parent_class;
};

struct _HistoryEntry {
	GObject parent_instance;
	HistoryEntryPrivate * priv;
	GDateTime* date;
	guint width;
	guint height;
	guint n_colors;
	guint score;
};

struct _HistoryEntryClass {
	GObjectClass parent_class;
};


static gpointer score_dialog_parent_class = NULL;

GType score_dialog_get_type (void) G_GNUC_CONST;
GType history_get_type (void) G_GNUC_CONST;
GType history_entry_get_type (void) G_GNUC_CONST;
#define SCORE_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SCORE_DIALOG, ScoreDialogPrivate))
enum  {
	SCORE_DIALOG_DUMMY_PROPERTY
};
ScoreDialog* score_dialog_new (History* history, HistoryEntry* selected_entry, gboolean show_quit);
ScoreDialog* score_dialog_construct (GType object_type, History* history, HistoryEntry* selected_entry, gboolean show_quit);
static void score_dialog_entry_added_cb (ScoreDialog* self, HistoryEntry* entry);
static void _score_dialog_entry_added_cb_history_entry_added (History* _sender, HistoryEntry* entry, gpointer self);
static void score_dialog_size_changed_cb (ScoreDialog* self, GtkComboBox* combo);
static void _score_dialog_size_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender, gpointer self);
void score_dialog_set_size (ScoreDialog* self, guint width, guint height, guint n_colors);
static gint score_dialog_compare_entries (HistoryEntry* a, HistoryEntry* b);
static gint _score_dialog_compare_entries_gcompare_func (gconstpointer a, gconstpointer b);
static void score_dialog_finalize (GObject* obj);


static gpointer _g_object_ref0 (gpointer self) {
#line 22 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 131 "score-dialog.c"
}


static void _score_dialog_entry_added_cb_history_entry_added (History* _sender, HistoryEntry* entry, gpointer self) {
#line 23 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	score_dialog_entry_added_cb ((ScoreDialog*) self, entry);
#line 138 "score-dialog.c"
}


static void _score_dialog_size_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender, gpointer self) {
#line 51 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	score_dialog_size_changed_cb ((ScoreDialog*) self, _sender);
#line 145 "score-dialog.c"
}


ScoreDialog* score_dialog_construct (GType object_type, History* history, HistoryEntry* selected_entry, gboolean show_quit) {
	ScoreDialog * self = NULL;
	History* _tmp0_ = NULL;
	History* _tmp1_ = NULL;
	History* _tmp2_ = NULL;
	HistoryEntry* _tmp3_ = NULL;
	HistoryEntry* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	GtkBox* vbox = NULL;
	GtkBox* _tmp9_ = NULL;
	GtkBox* _tmp10_ = NULL;
	GtkBox* _tmp11_ = NULL;
	GtkBox* _tmp12_ = NULL;
	GtkBox* _tmp13_ = NULL;
	GtkBox* hbox = NULL;
	GtkBox* _tmp14_ = NULL;
	GtkBox* _tmp15_ = NULL;
	GtkBox* _tmp16_ = NULL;
	GtkBox* _tmp17_ = NULL;
	GtkLabel* label = NULL;
	const gchar* _tmp18_ = NULL;
	GtkLabel* _tmp19_ = NULL;
	GtkLabel* _tmp20_ = NULL;
	GtkBox* _tmp21_ = NULL;
	GtkLabel* _tmp22_ = NULL;
	GtkListStore* _tmp23_ = NULL;
	GtkComboBox* _tmp24_ = NULL;
	GtkComboBox* _tmp25_ = NULL;
	GtkComboBox* _tmp26_ = NULL;
	GtkListStore* _tmp27_ = NULL;
	GtkCellRendererText* renderer = NULL;
	GtkCellRendererText* _tmp28_ = NULL;
	GtkComboBox* _tmp29_ = NULL;
	GtkCellRendererText* _tmp30_ = NULL;
	GtkComboBox* _tmp31_ = NULL;
	GtkCellRendererText* _tmp32_ = NULL;
	GtkComboBox* _tmp33_ = NULL;
	GtkBox* _tmp34_ = NULL;
	GtkComboBox* _tmp35_ = NULL;
	GtkScrolledWindow* scroll = NULL;
	GtkScrolledWindow* _tmp36_ = NULL;
	GtkScrolledWindow* _tmp37_ = NULL;
	GtkScrolledWindow* _tmp38_ = NULL;
	GtkScrolledWindow* _tmp39_ = NULL;
	GtkBox* _tmp40_ = NULL;
	GtkScrolledWindow* _tmp41_ = NULL;
	GtkListStore* _tmp42_ = NULL;
	GtkTreeView* _tmp43_ = NULL;
	GtkCellRendererText* _tmp44_ = NULL;
	GtkTreeView* _tmp45_ = NULL;
	const gchar* _tmp46_ = NULL;
	GtkCellRendererText* _tmp47_ = NULL;
	GtkCellRendererText* _tmp48_ = NULL;
	GtkCellRendererText* _tmp49_ = NULL;
	GtkTreeView* _tmp50_ = NULL;
	const gchar* _tmp51_ = NULL;
	GtkCellRendererText* _tmp52_ = NULL;
	GtkTreeView* _tmp53_ = NULL;
	GtkListStore* _tmp54_ = NULL;
	GtkTreeView* _tmp55_ = NULL;
	GtkScrolledWindow* _tmp56_ = NULL;
	GtkTreeView* _tmp57_ = NULL;
	History* _tmp58_ = NULL;
	GList* _tmp59_ = NULL;
#line 20 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	g_return_val_if_fail (history != NULL, NULL);
#line 20 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	self = (ScoreDialog*) g_object_new (object_type, NULL);
#line 22 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp0_ = history;
#line 22 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 22 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_g_object_unref0 (self->priv->history);
#line 22 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	self->priv->history = _tmp1_;
#line 23 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp2_ = history;
#line 23 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	g_signal_connect_object (_tmp2_, "entry-added", (GCallback) _score_dialog_entry_added_cb_history_entry_added, self, 0);
#line 24 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp3_ = selected_entry;
#line 24 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 24 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_g_object_unref0 (self->priv->selected_entry);
#line 24 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	self->priv->selected_entry = _tmp4_;
#line 26 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp5_ = show_quit;
#line 26 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	if (_tmp5_) {
#line 241 "score-dialog.c"
		const gchar* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
#line 28 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp6_ = _ ("_Quit");
#line 28 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		gtk_dialog_add_button ((GtkDialog*) self, _tmp6_, (gint) GTK_RESPONSE_CLOSE);
#line 29 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp7_ = _ ("New Game");
#line 29 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		gtk_dialog_add_button ((GtkDialog*) self, _tmp7_, (gint) GTK_RESPONSE_OK);
#line 252 "score-dialog.c"
	} else {
		const gchar* _tmp8_ = NULL;
#line 32 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp8_ = _ ("_OK");
#line 32 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		gtk_dialog_add_button ((GtkDialog*) self, _tmp8_, (gint) GTK_RESPONSE_DELETE_EVENT);
#line 259 "score-dialog.c"
	}
#line 33 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, 200, 300);
#line 35 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp9_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 5);
#line 35 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	g_object_ref_sink (_tmp9_);
#line 35 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	vbox = _tmp9_;
#line 36 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp10_ = vbox;
#line 36 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	gtk_container_set_border_width ((GtkContainer*) _tmp10_, (guint) 6);
#line 37 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp11_ = vbox;
#line 37 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	gtk_widget_show ((GtkWidget*) _tmp11_);
#line 38 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp12_ = (GtkBox*) gtk_dialog_get_content_area ((GtkDialog*) self);
#line 38 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp13_ = vbox;
#line 38 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	gtk_box_pack_start (_tmp12_, (GtkWidget*) _tmp13_, TRUE, TRUE, (guint) 0);
#line 40 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp14_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 40 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	g_object_ref_sink (_tmp14_);
#line 40 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	hbox = _tmp14_;
#line 41 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp15_ = hbox;
#line 41 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	gtk_widget_show ((GtkWidget*) _tmp15_);
#line 42 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp16_ = vbox;
#line 42 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp17_ = hbox;
#line 42 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	gtk_box_pack_start (_tmp16_, (GtkWidget*) _tmp17_, FALSE, FALSE, (guint) 0);
#line 44 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp18_ = _ ("Size:");
#line 44 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp19_ = (GtkLabel*) gtk_label_new (_tmp18_);
#line 44 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	g_object_ref_sink (_tmp19_);
#line 44 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	label = _tmp19_;
#line 45 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp20_ = label;
#line 45 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	gtk_widget_show ((GtkWidget*) _tmp20_);
#line 46 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp21_ = hbox;
#line 46 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp22_ = label;
#line 46 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	gtk_box_pack_start (_tmp21_, (GtkWidget*) _tmp22_, FALSE, FALSE, (guint) 0);
#line 48 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp23_ = gtk_list_store_new (4, G_TYPE_STRING, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT, -1);
#line 48 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_g_object_unref0 (self->priv->size_model);
#line 48 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	self->priv->size_model = _tmp23_;
#line 50 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp24_ = (GtkComboBox*) gtk_combo_box_new ();
#line 50 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	g_object_ref_sink (_tmp24_);
#line 50 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_g_object_unref0 (self->priv->size_combo);
#line 50 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	self->priv->size_combo = _tmp24_;
#line 51 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp25_ = self->priv->size_combo;
#line 51 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	g_signal_connect_object (_tmp25_, "changed", (GCallback) _score_dialog_size_changed_cb_gtk_combo_box_changed, self, 0);
#line 52 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp26_ = self->priv->size_combo;
#line 52 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp27_ = self->priv->size_model;
#line 52 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	gtk_combo_box_set_model (_tmp26_, (GtkTreeModel*) _tmp27_);
#line 53 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp28_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 53 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	g_object_ref_sink (_tmp28_);
#line 53 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	renderer = _tmp28_;
#line 54 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp29_ = self->priv->size_combo;
#line 54 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp30_ = renderer;
#line 54 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp29_, (GtkCellRenderer*) _tmp30_, TRUE);
#line 55 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp31_ = self->priv->size_combo;
#line 55 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp32_ = renderer;
#line 55 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp31_, (GtkCellRenderer*) _tmp32_, "text", 0);
#line 56 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp33_ = self->priv->size_combo;
#line 56 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	gtk_widget_show ((GtkWidget*) _tmp33_);
#line 57 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp34_ = hbox;
#line 57 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp35_ = self->priv->size_combo;
#line 57 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	gtk_box_pack_start (_tmp34_, (GtkWidget*) _tmp35_, TRUE, TRUE, (guint) 0);
#line 59 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp36_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 59 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	g_object_ref_sink (_tmp36_);
#line 59 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	scroll = _tmp36_;
#line 60 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp37_ = scroll;
#line 60 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	gtk_scrolled_window_set_shadow_type (_tmp37_, GTK_SHADOW_ETCHED_IN);
#line 61 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp38_ = scroll;
#line 61 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	gtk_scrolled_window_set_policy (_tmp38_, GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
#line 62 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp39_ = scroll;
#line 62 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	gtk_widget_show ((GtkWidget*) _tmp39_);
#line 63 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp40_ = vbox;
#line 63 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp41_ = scroll;
#line 63 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	gtk_box_pack_start (_tmp40_, (GtkWidget*) _tmp41_, TRUE, TRUE, (guint) 0);
#line 65 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp42_ = gtk_list_store_new (3, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_INT, -1);
#line 65 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_g_object_unref0 (self->priv->score_model);
#line 65 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	self->priv->score_model = _tmp42_;
#line 67 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp43_ = (GtkTreeView*) gtk_tree_view_new ();
#line 67 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	g_object_ref_sink (_tmp43_);
#line 67 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_g_object_unref0 (self->priv->scores);
#line 67 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	self->priv->scores = _tmp43_;
#line 68 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp44_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 68 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	g_object_ref_sink (_tmp44_);
#line 68 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_g_object_unref0 (renderer);
#line 68 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	renderer = _tmp44_;
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp45_ = self->priv->scores;
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp46_ = _ ("Date");
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp47_ = renderer;
#line 69 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp45_, -1, _tmp46_, (GtkCellRenderer*) _tmp47_, "text", 0, "weight", 2, NULL);
#line 70 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp48_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 70 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	g_object_ref_sink (_tmp48_);
#line 70 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_g_object_unref0 (renderer);
#line 70 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	renderer = _tmp48_;
#line 71 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp49_ = renderer;
#line 71 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	g_object_set ((GtkCellRenderer*) _tmp49_, "xalign", 1.0f, NULL);
#line 72 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp50_ = self->priv->scores;
#line 72 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp51_ = _ ("Score");
#line 72 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp52_ = renderer;
#line 72 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp50_, -1, _tmp51_, (GtkCellRenderer*) _tmp52_, "text", 1, "weight", 2, NULL);
#line 73 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp53_ = self->priv->scores;
#line 73 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp54_ = self->priv->score_model;
#line 73 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	gtk_tree_view_set_model (_tmp53_, (GtkTreeModel*) _tmp54_);
#line 74 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp55_ = self->priv->scores;
#line 74 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	gtk_widget_show ((GtkWidget*) _tmp55_);
#line 75 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp56_ = scroll;
#line 75 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp57_ = self->priv->scores;
#line 75 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	gtk_container_add ((GtkContainer*) _tmp56_, (GtkWidget*) _tmp57_);
#line 77 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp58_ = history;
#line 77 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp59_ = _tmp58_->entries;
#line 463 "score-dialog.c"
	{
		GList* entry_collection = NULL;
		GList* entry_it = NULL;
#line 77 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		entry_collection = _tmp59_;
#line 77 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		for (entry_it = entry_collection; entry_it != NULL; entry_it = entry_it->next) {
#line 471 "score-dialog.c"
			HistoryEntry* _tmp60_ = NULL;
			HistoryEntry* entry = NULL;
#line 77 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			_tmp60_ = _g_object_ref0 ((HistoryEntry*) entry_it->data);
#line 77 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			entry = _tmp60_;
#line 478 "score-dialog.c"
			{
				HistoryEntry* _tmp61_ = NULL;
#line 78 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp61_ = entry;
#line 78 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				score_dialog_entry_added_cb (self, _tmp61_);
#line 77 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_g_object_unref0 (entry);
#line 487 "score-dialog.c"
			}
		}
	}
#line 20 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_g_object_unref0 (scroll);
#line 20 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_g_object_unref0 (renderer);
#line 20 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_g_object_unref0 (label);
#line 20 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_g_object_unref0 (hbox);
#line 20 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_g_object_unref0 (vbox);
#line 20 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	return self;
#line 503 "score-dialog.c"
}


ScoreDialog* score_dialog_new (History* history, HistoryEntry* selected_entry, gboolean show_quit) {
#line 20 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	return score_dialog_construct (TYPE_SCORE_DIALOG, history, selected_entry, show_quit);
#line 510 "score-dialog.c"
}


static gint _score_dialog_compare_entries_gcompare_func (gconstpointer a, gconstpointer b) {
	gint result;
	result = score_dialog_compare_entries ((HistoryEntry*) a, (HistoryEntry*) b);
#line 86 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	return result;
#line 519 "score-dialog.c"
}


void score_dialog_set_size (ScoreDialog* self, guint width, guint height, guint n_colors) {
	GtkListStore* _tmp0_ = NULL;
	GList* entries = NULL;
	History* _tmp1_ = NULL;
	GList* _tmp2_ = NULL;
	GList* _tmp3_ = NULL;
	GList* _tmp4_ = NULL;
#line 81 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	g_return_if_fail (self != NULL);
#line 83 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp0_ = self->priv->score_model;
#line 83 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	gtk_list_store_clear (_tmp0_);
#line 85 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp1_ = self->priv->history;
#line 85 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp2_ = _tmp1_->entries;
#line 85 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp3_ = g_list_copy (_tmp2_);
#line 85 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	entries = _tmp3_;
#line 86 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	entries = g_list_sort (entries, _score_dialog_compare_entries_gcompare_func);
#line 88 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp4_ = entries;
#line 548 "score-dialog.c"
	{
		GList* entry_collection = NULL;
		GList* entry_it = NULL;
#line 88 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		entry_collection = _tmp4_;
#line 88 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		for (entry_it = entry_collection; entry_it != NULL; entry_it = entry_it->next) {
#line 556 "score-dialog.c"
			HistoryEntry* entry = NULL;
#line 88 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			entry = (HistoryEntry*) entry_it->data;
#line 560 "score-dialog.c"
			{
				gboolean _tmp5_ = FALSE;
				gboolean _tmp6_ = FALSE;
				HistoryEntry* _tmp7_ = NULL;
				guint _tmp8_ = 0U;
				guint _tmp9_ = 0U;
				gchar* date_label = NULL;
				HistoryEntry* _tmp16_ = NULL;
				GDateTime* _tmp17_ = NULL;
				gchar* _tmp18_ = NULL;
				gchar* score_label = NULL;
				HistoryEntry* _tmp19_ = NULL;
				guint _tmp20_ = 0U;
				gchar* _tmp21_ = NULL;
				gint weight = 0;
				HistoryEntry* _tmp22_ = NULL;
				HistoryEntry* _tmp23_ = NULL;
				GtkTreeIter iter = {0};
				GtkListStore* _tmp24_ = NULL;
				GtkTreeIter _tmp25_ = {0};
				GtkListStore* _tmp26_ = NULL;
				GtkTreeIter _tmp27_ = {0};
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_ = NULL;
				gint _tmp30_ = 0;
				HistoryEntry* _tmp31_ = NULL;
				HistoryEntry* _tmp32_ = NULL;
#line 90 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp7_ = entry;
#line 90 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp8_ = _tmp7_->width;
#line 90 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp9_ = width;
#line 90 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				if (_tmp8_ != _tmp9_) {
#line 90 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp6_ = TRUE;
#line 598 "score-dialog.c"
				} else {
					HistoryEntry* _tmp10_ = NULL;
					guint _tmp11_ = 0U;
					guint _tmp12_ = 0U;
#line 90 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp10_ = entry;
#line 90 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp11_ = _tmp10_->height;
#line 90 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp12_ = height;
#line 90 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp6_ = _tmp11_ != _tmp12_;
#line 611 "score-dialog.c"
				}
#line 90 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				if (_tmp6_) {
#line 90 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp5_ = TRUE;
#line 617 "score-dialog.c"
				} else {
					HistoryEntry* _tmp13_ = NULL;
					guint _tmp14_ = 0U;
					guint _tmp15_ = 0U;
#line 90 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp13_ = entry;
#line 90 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp14_ = _tmp13_->n_colors;
#line 90 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp15_ = n_colors;
#line 90 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp5_ = _tmp14_ != _tmp15_;
#line 630 "score-dialog.c"
				}
#line 90 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				if (_tmp5_) {
#line 91 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					continue;
#line 636 "score-dialog.c"
				}
#line 93 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp16_ = entry;
#line 93 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp17_ = _tmp16_->date;
#line 93 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp18_ = g_date_time_format (_tmp17_, "%d/%m/%Y");
#line 93 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				date_label = _tmp18_;
#line 95 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp19_ = entry;
#line 95 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp20_ = _tmp19_->score;
#line 95 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp21_ = g_strdup_printf ("%u", _tmp20_);
#line 95 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				score_label = _tmp21_;
#line 97 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				weight = (gint) PANGO_WEIGHT_NORMAL;
#line 98 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp22_ = entry;
#line 98 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp23_ = self->priv->selected_entry;
#line 98 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				if (_tmp22_ == _tmp23_) {
#line 99 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					weight = (gint) PANGO_WEIGHT_BOLD;
#line 664 "score-dialog.c"
				}
#line 102 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp24_ = self->priv->score_model;
#line 102 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				gtk_list_store_append (_tmp24_, &_tmp25_);
#line 102 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				iter = _tmp25_;
#line 103 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp26_ = self->priv->score_model;
#line 103 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp27_ = iter;
#line 103 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp28_ = date_label;
#line 103 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp29_ = score_label;
#line 103 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp30_ = weight;
#line 103 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				gtk_list_store_set (_tmp26_, &_tmp27_, 0, _tmp28_, 1, _tmp29_, 2, _tmp30_, -1);
#line 105 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp31_ = entry;
#line 105 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp32_ = self->priv->selected_entry;
#line 105 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				if (_tmp31_ == _tmp32_) {
#line 690 "score-dialog.c"
					GtkTreeIter piter = {0};
					GtkTreeIter _tmp33_ = {0};
					GtkListStore* _tmp34_ = NULL;
					gboolean _tmp35_ = FALSE;
					GtkTreeView* _tmp41_ = NULL;
					GtkListStore* _tmp42_ = NULL;
					GtkTreeIter _tmp43_ = {0};
					GtkTreePath* _tmp44_ = NULL;
					GtkTreePath* _tmp45_ = NULL;
#line 107 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp33_ = iter;
#line 107 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					piter = _tmp33_;
#line 108 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp34_ = self->priv->score_model;
#line 108 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp35_ = gtk_tree_model_iter_previous ((GtkTreeModel*) _tmp34_, &piter);
#line 108 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					if (_tmp35_) {
#line 710 "score-dialog.c"
						GtkTreeIter ppiter = {0};
						GtkTreeIter _tmp36_ = {0};
						GtkListStore* _tmp37_ = NULL;
						gboolean _tmp38_ = FALSE;
#line 110 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
						_tmp36_ = piter;
#line 110 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
						ppiter = _tmp36_;
#line 111 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
						_tmp37_ = self->priv->score_model;
#line 111 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
						_tmp38_ = gtk_tree_model_iter_previous ((GtkTreeModel*) _tmp37_, &ppiter);
#line 111 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
						if (_tmp38_) {
#line 725 "score-dialog.c"
							GtkTreeIter _tmp39_ = {0};
#line 112 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
							_tmp39_ = ppiter;
#line 112 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
							piter = _tmp39_;
#line 731 "score-dialog.c"
						}
					} else {
						GtkTreeIter _tmp40_ = {0};
#line 115 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
						_tmp40_ = iter;
#line 115 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
						piter = _tmp40_;
#line 739 "score-dialog.c"
					}
#line 116 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp41_ = self->priv->scores;
#line 116 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp42_ = self->priv->score_model;
#line 116 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp43_ = piter;
#line 116 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp44_ = gtk_tree_model_get_path ((GtkTreeModel*) _tmp42_, &_tmp43_);
#line 116 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp45_ = _tmp44_;
#line 116 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					gtk_tree_view_scroll_to_cell (_tmp41_, _tmp45_, NULL, FALSE, (gfloat) 0, (gfloat) 0);
#line 116 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_gtk_tree_path_free0 (_tmp45_);
#line 755 "score-dialog.c"
				}
#line 88 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_g_free0 (score_label);
#line 88 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_g_free0 (date_label);
#line 761 "score-dialog.c"
			}
		}
	}
#line 81 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_g_list_free0 (entries);
#line 767 "score-dialog.c"
}


static gint score_dialog_compare_entries (HistoryEntry* a, HistoryEntry* b) {
	gint result = 0;
	HistoryEntry* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	HistoryEntry* _tmp2_ = NULL;
	guint _tmp3_ = 0U;
	HistoryEntry* _tmp8_ = NULL;
	guint _tmp9_ = 0U;
	HistoryEntry* _tmp10_ = NULL;
	guint _tmp11_ = 0U;
	HistoryEntry* _tmp16_ = NULL;
	guint _tmp17_ = 0U;
	HistoryEntry* _tmp18_ = NULL;
	guint _tmp19_ = 0U;
	HistoryEntry* _tmp24_ = NULL;
	guint _tmp25_ = 0U;
	HistoryEntry* _tmp26_ = NULL;
	guint _tmp27_ = 0U;
	HistoryEntry* _tmp32_ = NULL;
	GDateTime* _tmp33_ = NULL;
	HistoryEntry* _tmp34_ = NULL;
	GDateTime* _tmp35_ = NULL;
	gint _tmp36_ = 0;
#line 121 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 121 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 123 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp0_ = a;
#line 123 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp1_ = _tmp0_->width;
#line 123 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp2_ = b;
#line 123 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp3_ = _tmp2_->width;
#line 123 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	if (_tmp1_ != _tmp3_) {
#line 808 "score-dialog.c"
		HistoryEntry* _tmp4_ = NULL;
		guint _tmp5_ = 0U;
		HistoryEntry* _tmp6_ = NULL;
		guint _tmp7_ = 0U;
#line 124 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp4_ = a;
#line 124 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp5_ = _tmp4_->width;
#line 124 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp6_ = b;
#line 124 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp7_ = _tmp6_->width;
#line 124 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		result = ((gint) _tmp5_) - ((gint) _tmp7_);
#line 124 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		return result;
#line 825 "score-dialog.c"
	}
#line 125 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp8_ = a;
#line 125 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp9_ = _tmp8_->height;
#line 125 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp10_ = b;
#line 125 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp11_ = _tmp10_->height;
#line 125 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	if (_tmp9_ != _tmp11_) {
#line 837 "score-dialog.c"
		HistoryEntry* _tmp12_ = NULL;
		guint _tmp13_ = 0U;
		HistoryEntry* _tmp14_ = NULL;
		guint _tmp15_ = 0U;
#line 126 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp12_ = a;
#line 126 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp13_ = _tmp12_->height;
#line 126 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp14_ = b;
#line 126 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp15_ = _tmp14_->height;
#line 126 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		result = ((gint) _tmp13_) - ((gint) _tmp15_);
#line 126 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		return result;
#line 854 "score-dialog.c"
	}
#line 127 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp16_ = a;
#line 127 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp17_ = _tmp16_->n_colors;
#line 127 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp18_ = b;
#line 127 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp19_ = _tmp18_->n_colors;
#line 127 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	if (_tmp17_ != _tmp19_) {
#line 866 "score-dialog.c"
		HistoryEntry* _tmp20_ = NULL;
		guint _tmp21_ = 0U;
		HistoryEntry* _tmp22_ = NULL;
		guint _tmp23_ = 0U;
#line 128 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp20_ = a;
#line 128 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp21_ = _tmp20_->n_colors;
#line 128 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp22_ = b;
#line 128 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp23_ = _tmp22_->n_colors;
#line 128 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		result = ((gint) _tmp21_) - ((gint) _tmp23_);
#line 128 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		return result;
#line 883 "score-dialog.c"
	}
#line 129 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp24_ = a;
#line 129 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp25_ = _tmp24_->score;
#line 129 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp26_ = b;
#line 129 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp27_ = _tmp26_->score;
#line 129 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	if (_tmp25_ != _tmp27_) {
#line 895 "score-dialog.c"
		HistoryEntry* _tmp28_ = NULL;
		guint _tmp29_ = 0U;
		HistoryEntry* _tmp30_ = NULL;
		guint _tmp31_ = 0U;
#line 130 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp28_ = a;
#line 130 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp29_ = _tmp28_->score;
#line 130 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp30_ = b;
#line 130 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp31_ = _tmp30_->score;
#line 130 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		result = ((gint) _tmp29_) - ((gint) _tmp31_);
#line 130 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		return result;
#line 912 "score-dialog.c"
	}
#line 131 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp32_ = a;
#line 131 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp33_ = _tmp32_->date;
#line 131 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp34_ = b;
#line 131 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp35_ = _tmp34_->date;
#line 131 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp36_ = g_date_time_compare (_tmp33_, _tmp35_);
#line 131 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	result = _tmp36_;
#line 131 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	return result;
#line 928 "score-dialog.c"
}


static void score_dialog_size_changed_cb (ScoreDialog* self, GtkComboBox* combo) {
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_ = NULL;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
	gint width = 0;
	gint height = 0;
	gint n_colors = 0;
	GtkComboBox* _tmp3_ = NULL;
	GtkTreeModel* _tmp4_ = NULL;
	GtkTreeModel* _tmp5_ = NULL;
	GtkTreeIter _tmp6_ = {0};
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
#line 134 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	g_return_if_fail (self != NULL);
#line 134 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	g_return_if_fail (combo != NULL);
#line 137 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp0_ = combo;
#line 137 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
#line 137 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	iter = _tmp1_;
#line 137 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	if (!_tmp2_) {
#line 138 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		return;
#line 961 "score-dialog.c"
	}
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp3_ = combo;
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp4_ = gtk_combo_box_get_model (_tmp3_);
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp5_ = _tmp4_;
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp6_ = iter;
#line 141 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	gtk_tree_model_get (_tmp5_, &_tmp6_, 1, &width, 2, &height, 3, &n_colors, -1);
#line 142 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp7_ = width;
#line 142 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp8_ = height;
#line 142 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp9_ = n_colors;
#line 142 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	score_dialog_set_size (self, (guint) _tmp7_, (guint) _tmp8_, (guint) _tmp9_);
#line 981 "score-dialog.c"
}


static void score_dialog_entry_added_cb (ScoreDialog* self, HistoryEntry* entry) {
	GtkTreeIter iter = {0};
	gboolean have_size_entry = FALSE;
	GtkListStore* _tmp0_ = NULL;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
	gboolean _tmp19_ = FALSE;
#line 145 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	g_return_if_fail (self != NULL);
#line 145 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	g_return_if_fail (entry != NULL);
#line 149 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	have_size_entry = FALSE;
#line 150 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp0_ = self->priv->size_model;
#line 150 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp2_ = gtk_tree_model_get_iter_first ((GtkTreeModel*) _tmp0_, &_tmp1_);
#line 150 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	iter = _tmp1_;
#line 150 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	if (_tmp2_) {
#line 1006 "score-dialog.c"
		{
			gboolean _tmp3_ = FALSE;
#line 152 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			_tmp3_ = TRUE;
#line 152 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			while (TRUE) {
#line 1013 "score-dialog.c"
				gint width = 0;
				gint height = 0;
				gint n_colors = 0;
				GtkListStore* _tmp6_ = NULL;
				GtkTreeIter _tmp7_ = {0};
				gboolean _tmp8_ = FALSE;
				gboolean _tmp9_ = FALSE;
				gint _tmp10_ = 0;
				HistoryEntry* _tmp11_ = NULL;
				guint _tmp12_ = 0U;
#line 152 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				if (!_tmp3_) {
#line 1026 "score-dialog.c"
					GtkListStore* _tmp4_ = NULL;
					gboolean _tmp5_ = FALSE;
#line 161 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp4_ = self->priv->size_model;
#line 161 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp5_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp4_, &iter);
#line 161 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					if (!_tmp5_) {
#line 161 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
						break;
#line 1037 "score-dialog.c"
					}
				}
#line 152 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp3_ = FALSE;
#line 155 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp6_ = self->priv->size_model;
#line 155 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp7_ = iter;
#line 155 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				gtk_tree_model_get ((GtkTreeModel*) _tmp6_, &_tmp7_, 1, &width, 2, &height, 3, &n_colors, -1);
#line 156 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp10_ = width;
#line 156 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp11_ = entry;
#line 156 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				_tmp12_ = _tmp11_->width;
#line 156 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				if (((guint) _tmp10_) == _tmp12_) {
#line 1056 "score-dialog.c"
					gint _tmp13_ = 0;
					HistoryEntry* _tmp14_ = NULL;
					guint _tmp15_ = 0U;
#line 156 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp13_ = height;
#line 156 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp14_ = entry;
#line 156 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp15_ = _tmp14_->height;
#line 156 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp9_ = ((guint) _tmp13_) == _tmp15_;
#line 1068 "score-dialog.c"
				} else {
#line 156 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp9_ = FALSE;
#line 1072 "score-dialog.c"
				}
#line 156 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				if (_tmp9_) {
#line 1076 "score-dialog.c"
					gint _tmp16_ = 0;
					HistoryEntry* _tmp17_ = NULL;
					guint _tmp18_ = 0U;
#line 156 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp16_ = n_colors;
#line 156 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp17_ = entry;
#line 156 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp18_ = _tmp17_->n_colors;
#line 156 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp8_ = ((guint) _tmp16_) == _tmp18_;
#line 1088 "score-dialog.c"
				} else {
#line 156 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					_tmp8_ = FALSE;
#line 1092 "score-dialog.c"
				}
#line 156 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
				if (_tmp8_) {
#line 158 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					have_size_entry = TRUE;
#line 159 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
					break;
#line 1100 "score-dialog.c"
				}
			}
		}
	}
#line 164 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_tmp19_ = have_size_entry;
#line 164 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	if (!_tmp19_) {
#line 1109 "score-dialog.c"
		gchar* label = NULL;
		HistoryEntry* _tmp20_ = NULL;
		guint _tmp21_ = 0U;
		const gchar* _tmp22_ = NULL;
		HistoryEntry* _tmp23_ = NULL;
		guint _tmp24_ = 0U;
		HistoryEntry* _tmp25_ = NULL;
		guint _tmp26_ = 0U;
		HistoryEntry* _tmp27_ = NULL;
		guint _tmp28_ = 0U;
		gchar* _tmp29_ = NULL;
		GtkListStore* _tmp30_ = NULL;
		GtkTreeIter _tmp31_ = {0};
		GtkListStore* _tmp32_ = NULL;
		GtkTreeIter _tmp33_ = {0};
		const gchar* _tmp34_ = NULL;
		HistoryEntry* _tmp35_ = NULL;
		guint _tmp36_ = 0U;
		HistoryEntry* _tmp37_ = NULL;
		guint _tmp38_ = 0U;
		HistoryEntry* _tmp39_ = NULL;
		guint _tmp40_ = 0U;
		GtkComboBox* _tmp41_ = NULL;
		gint _tmp42_ = 0;
		gboolean _tmp45_ = FALSE;
		gboolean _tmp46_ = FALSE;
		gboolean _tmp47_ = FALSE;
		HistoryEntry* _tmp48_ = NULL;
#line 166 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp20_ = entry;
#line 166 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp21_ = _tmp20_->n_colors;
#line 166 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp22_ = ngettext ("%u × %u, %u color", "%u × %u, %u colors", (gulong) _tmp21_);
#line 166 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp23_ = entry;
#line 166 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp24_ = _tmp23_->width;
#line 166 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp25_ = entry;
#line 166 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp26_ = _tmp25_->height;
#line 166 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp27_ = entry;
#line 166 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp28_ = _tmp27_->n_colors;
#line 166 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp29_ = g_strdup_printf (_tmp22_, _tmp24_, _tmp26_, _tmp28_);
#line 166 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		label = _tmp29_;
#line 168 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp30_ = self->priv->size_model;
#line 168 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		gtk_list_store_append (_tmp30_, &_tmp31_);
#line 168 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		iter = _tmp31_;
#line 169 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp32_ = self->priv->size_model;
#line 169 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp33_ = iter;
#line 169 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp34_ = label;
#line 169 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp35_ = entry;
#line 169 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp36_ = _tmp35_->width;
#line 169 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp37_ = entry;
#line 169 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp38_ = _tmp37_->height;
#line 169 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp39_ = entry;
#line 169 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp40_ = _tmp39_->n_colors;
#line 169 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		gtk_list_store_set (_tmp32_, &_tmp33_, 0, _tmp34_, 1, _tmp36_, 2, _tmp38_, 3, _tmp40_, -1);
#line 172 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp41_ = self->priv->size_combo;
#line 172 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp42_ = gtk_combo_box_get_active (_tmp41_);
#line 172 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		if (_tmp42_ == -1) {
#line 1192 "score-dialog.c"
			GtkComboBox* _tmp43_ = NULL;
			GtkTreeIter _tmp44_ = {0};
#line 173 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			_tmp43_ = self->priv->size_combo;
#line 173 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			_tmp44_ = iter;
#line 173 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			gtk_combo_box_set_active_iter (_tmp43_, &_tmp44_);
#line 1201 "score-dialog.c"
		}
#line 176 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_tmp48_ = self->priv->selected_entry;
#line 176 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		if (_tmp48_ != NULL) {
#line 1207 "score-dialog.c"
			HistoryEntry* _tmp49_ = NULL;
			guint _tmp50_ = 0U;
			HistoryEntry* _tmp51_ = NULL;
			guint _tmp52_ = 0U;
#line 176 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			_tmp49_ = entry;
#line 176 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			_tmp50_ = _tmp49_->width;
#line 176 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			_tmp51_ = self->priv->selected_entry;
#line 176 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			_tmp52_ = _tmp51_->width;
#line 176 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			_tmp47_ = _tmp50_ == _tmp52_;
#line 1222 "score-dialog.c"
		} else {
#line 176 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			_tmp47_ = FALSE;
#line 1226 "score-dialog.c"
		}
#line 176 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		if (_tmp47_) {
#line 1230 "score-dialog.c"
			HistoryEntry* _tmp53_ = NULL;
			guint _tmp54_ = 0U;
			HistoryEntry* _tmp55_ = NULL;
			guint _tmp56_ = 0U;
#line 176 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			_tmp53_ = entry;
#line 176 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			_tmp54_ = _tmp53_->height;
#line 176 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			_tmp55_ = self->priv->selected_entry;
#line 176 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			_tmp56_ = _tmp55_->height;
#line 176 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			_tmp46_ = _tmp54_ == _tmp56_;
#line 1245 "score-dialog.c"
		} else {
#line 176 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			_tmp46_ = FALSE;
#line 1249 "score-dialog.c"
		}
#line 176 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		if (_tmp46_) {
#line 1253 "score-dialog.c"
			HistoryEntry* _tmp57_ = NULL;
			guint _tmp58_ = 0U;
			HistoryEntry* _tmp59_ = NULL;
			guint _tmp60_ = 0U;
#line 176 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			_tmp57_ = entry;
#line 176 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			_tmp58_ = _tmp57_->n_colors;
#line 176 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			_tmp59_ = self->priv->selected_entry;
#line 176 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			_tmp60_ = _tmp59_->n_colors;
#line 176 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			_tmp45_ = _tmp58_ == _tmp60_;
#line 1268 "score-dialog.c"
		} else {
#line 176 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			_tmp45_ = FALSE;
#line 1272 "score-dialog.c"
		}
#line 176 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		if (_tmp45_) {
#line 1276 "score-dialog.c"
			GtkComboBox* _tmp61_ = NULL;
			GtkTreeIter _tmp62_ = {0};
#line 177 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			_tmp61_ = self->priv->size_combo;
#line 177 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			_tmp62_ = iter;
#line 177 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
			gtk_combo_box_set_active_iter (_tmp61_, &_tmp62_);
#line 1285 "score-dialog.c"
		}
#line 164 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
		_g_free0 (label);
#line 1289 "score-dialog.c"
	}
}


static void score_dialog_class_init (ScoreDialogClass * klass) {
#line 11 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	score_dialog_parent_class = g_type_class_peek_parent (klass);
#line 11 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	g_type_class_add_private (klass, sizeof (ScoreDialogPrivate));
#line 11 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = score_dialog_finalize;
#line 1301 "score-dialog.c"
}


static void score_dialog_instance_init (ScoreDialog * self) {
#line 11 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	self->priv = SCORE_DIALOG_GET_PRIVATE (self);
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	self->priv->selected_entry = NULL;
#line 1310 "score-dialog.c"
}


static void score_dialog_finalize (GObject* obj) {
	ScoreDialog * self;
#line 11 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SCORE_DIALOG, ScoreDialog);
#line 13 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_g_object_unref0 (self->priv->history);
#line 14 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_g_object_unref0 (self->priv->selected_entry);
#line 15 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_g_object_unref0 (self->priv->size_model);
#line 16 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_g_object_unref0 (self->priv->score_model);
#line 17 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_g_object_unref0 (self->priv->size_combo);
#line 18 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	_g_object_unref0 (self->priv->scores);
#line 11 "/home/mcatanzaro/jhbuild/checkout/swell-foop/src/score-dialog.vala"
	G_OBJECT_CLASS (score_dialog_parent_class)->finalize (obj);
#line 1332 "score-dialog.c"
}


GType score_dialog_get_type (void) {
	static volatile gsize score_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&score_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ScoreDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) score_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ScoreDialog), 0, (GInstanceInitFunc) score_dialog_instance_init, NULL };
		GType score_dialog_type_id;
		score_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "ScoreDialog", &g_define_type_info, 0);
		g_once_init_leave (&score_dialog_type_id__volatile, score_dialog_type_id);
	}
	return score_dialog_type_id__volatile;
}



